<?php
/* -----------------------------------------------------------------------------
  Plugin     : Translator
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  AIP classe => manage integration in administration interface

  --------------------------------------------------------------------------- */

  include_once(PHPWG_ROOT_PATH.'admin/include/pclzip.lib.php');
  include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
  include_once(TRANSLATOR_PATH.'translator_root.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/translate.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/css.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/pages_navigation.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/tables.class.inc.php');

  /* classe translator pour l'administration */
  class Translator_AIP extends Translator_root
  {
    protected $tabsheets;
    protected $css;   //the css object
    protected $google_translate;

    function Translator_AIP($prefixeTable, $filelocation)
    {
      global $user;

      parent::__construct($prefixeTable, $filelocation);

      $this->init_user_nfo($user);

      $this->tabsheets=new tabsheet();
      $this->css = new css(dirname($this->filelocation).'/'.$this->plugin_name_files.".css");

      if(isset($_REQUEST['f_tabsheet'])&&$_REQUEST['f_tabsheet']=='editing')
      {
        //google js needed only if in translate page
        $this->google_translate = new translate();
      }

      //$this->tabsheets->set_titlename('TABSHEET_TITLE');
      $this->tabsheets->add('status',
                            l10n('g001_status'),
                            $this->page_link."&amp;f_tabsheet=status");
      if(isset($_REQUEST['f_tabsheet']) and $_REQUEST['f_tabsheet']=='editing')
      {
        $this->tabsheets->add('editing', l10n('g001_editing'),'');
      }
      $this->tabsheets->add('langs', l10n('g001_langs'),
                            $this->page_link."&amp;f_tabsheet=langs");
      $this->tabsheets->add('maintenance', l10n('g001_maintenance'),
                            $this->page_link."&amp;f_tabsheet=maintenance");
      $this->tabsheets->add('translators', l10n('g001_translators'),
                            $this->page_link."&amp;f_tabsheet=translators");
      if(!$this->is_translator())
      {
        $this->tabsheets->add('config', l10n('g001_config'),
                            $this->page_link."&amp;f_tabsheet=config");
      }

      $this->load_config();
      $this->init_events();
    }

    /*
      surchage of common_plugin->save_config function
    */
    function save_config()
    {
      if(parent::save_config())
      {
        $this->css->make_CSS($this->generate_CSS());
        return(true);
      }
      return(false);
    }

    /*
      surchage of common_plugin->load_config function
    */
    function load_config()
    {
      parent::load_config();
      if(!$this->css->css_file_exists())
      {
        $this->css->make_CSS($this->generate_CSS());
      }
    }


    /*
      initialize events call for the plugin
    */
    function init_events()
    {
      //calling parent isn't need
      //parent::init_events();
      add_event_handler('loc_end_page_header', array(&$this->css, 'apply_CSS'));
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu'));
      //$this->css->make_CSS($this->generate_CSS());
    }

    /*
      generate the css code
    */
    function generate_CSS()
    {
      $text = "
.g001_graphbar1,
.g001_graphbar2,
.g001_graphbar3,
.g001_graphbar4,
.g001_graphbar5,
.g001_graphbarx {
    border:0px;
    height:8px;
    display: block;
    float:left;
    margin:0px;
    padding:0px;
    position:relative;
    top:3px;
  }
.g001_graphbar1 { background-color:#".$this->my_config['color_bars1']."; }
.g001_graphbar2 { background-color:#".$this->my_config['color_bars2']."; }
.g001_graphbar3 { background-color:#".$this->my_config['color_bars3']."; }
.g001_graphbar4 { background-color:#".$this->my_config['color_bars4']."; }
.g001_graphbar5 { background-color:#".$this->my_config['color_bars5']."; }
.g001_graphbarx { background-color:transparent; top:0px; height:1px; }

fieldset.translator {
  text-align:left;
}

.formtable {
  margin-left:0px;
  text-align:left;
}

.g001_table_row:hover
{
  background-color:#".$this->my_config['mouse_over_color'].";
  cursor:pointer;
}

.g001_table_row
{
  vertical-align:top;
}


.g001_table_r
{
  margin:2px; //2px
  padding:2px;
  text-align:left;
  font-size:90%;
  border-style:hidden;
  border-spacing:0px 1px;
}

.g001_table_r TH
{
  /*text-align:center;*/
  border-spacing:2px;
  padding:2px;
}

.g001_table_r TD
{
  padding-left:3px;
  padding-right:3px;
}

.g001_table_r .throw
{
  font-size:100%;
  font-weight:normal;
  line-height:18px;
  padding-top:0px;
}

.g001_table_nfo
{
  text-align:left;
}

.g001_menu
{
  padding:5px;
  background:#".$this->my_config['mouse_over_color'].";
  z-index:10000;
  font-size:90%;
}

.g001_help2, .g001_title
{
  text-align:left;
  font-weight:bold;
}

.g001_title
{
  font-size:120%;
}

.ttnfo
{
  color:#".$this->my_config['color_bars1'].";
}
.tvnfo
{
  color:#".$this->my_config['color_bars2'].";
}
.tonfo
{
  color:#".$this->my_config['color_bars3'].";
}
.tdnfo
{
  color:#".$this->my_config['color_bars4'].";
}
      ";
      return($text);
    }



    /* 
      display administration page
    */
    function display_admin_page()
    {
      global $template, $user;


      $template->set_filename('plugin_admin_content', dirname(__FILE__)."/admin/plugin_admin.tpl");

      //tabsheet management
      if(!isset($_REQUEST['f_tabsheet']))
      {
        $_REQUEST['f_tabsheet']='status';
      }

      $template_datas=array();

      $this->tabsheets->select($_REQUEST['f_tabsheet']);
      $this->tabsheets->assign();
      $selected_tab=$this->tabsheets->get_selected();

      switch($_REQUEST['f_tabsheet'])
      {
        case 'status':
          $this->display_status_page();
          /*
            status page displays list of all .lang.php file (by row) and available languages (by col)
              for each file possibility to :
                - compare translation => links to EDITING page
              for each file/language possibility to :
                - translate into an another available language => links to EDITING page
                - edit the file/language => links to EDITING page
          */
          break;
        case 'langs':
          $this->display_langs_page();
          /*
            langs page display list of all available language
            possibility to :
              - add a language => links to LANGS page
            for each language, possibility to :
              - edit language => links to LANGS page
              - delete language (sub edit function) => links to LANGS page
          */
          break;
        case 'maintenance':
          $this->display_maintenance_page();
          /*
            maintenance page allows to :
              - export database translation to .lang.php files (implementation not finished)  => links to MAINTENANCE/EXPORT page
              - purge database => links to MAINTENANCE/EXPORT page
                  consist to purge deleted items or to clean all items versions (only keep the last version of an item)
              - analyse differences between database translated files and disk's files (not implemented yet)
          */
          break;
        case 'editing':
          $this->display_editing_page();
          /*
            editing page allows to :
              - edit items of language file
              - compare languages file (display keys difference between languages files) 
          */
          break;
        case 'config': 
          $this->display_config_page();
          /*
            config page allows to :
              - set plugin's options
          */
          break;
        case 'translators':
          $this->display_translators_page();
          /*
            translators page allows to :
              - set users defined to translate
              - manage translators properties
          */
          break;
      }

      //translator mode management
      if(isset($user['translator_mode']))
      {
        $template_datas['DISP_TRANSLATOR_MODE']=l10n('g001_translator_mode_is_on');
        $template_datas['DISP_TRANSLATOR_ALTERNATE']=l10n('g001_deactivate_translator_mode');
        $modeonoff='off';
      }
      else
      {
        $template_datas['DISP_TRANSLATOR_MODE']=l10n('g001_translator_mode_is_off');
        $template_datas['DISP_TRANSLATOR_ALTERNATE']=l10n('g001_activate_translator_mode');
        $modeonoff='on';
      }
      $template_datas['AJAX_URL_TRANSLATOR_MODE']=$this->page_link."&ajaxfct=switch_tmode&f_translator_mode=".$modeonoff;
      $template_datas["TABSHEET_TITLE"]="[".$selected_tab['caption']."]";

      $template_plugin["PLUGIN_VERSION"] = "<i>".$this->plugin_name."</i> ".l10n('g001_pluginversion').TRANSLATOR_VERSION;
      $template_plugin["PATH"] = TRANSLATOR_PATH;

      $template->assign('plugin', $template_plugin);
      $template->assign('datas', $template_datas);
      $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
    } //display_admin_page

    /*
      return ajax content
    */
    function return_ajax_content()
    { 
      if(isset($_REQUEST['ajaxfct']))
      {
        $result="<p class='errors'>An error has occured</p>";
        switch($_REQUEST['ajaxfct'])
        {
          case 'translation_detail_list':
            $result=$this->ajax_translation_detail_list();
            break;
          case 'file_nfo':
            $result=$this->ajax_file_nfo();
            break;
          case 'load_edit_list':
            $result=$this->ajax_load_edit_list();
            break;
          case 'key_nfo':
            $result=$this->ajax_key_nfo();
            break;
          case 'allkey_nfo':
            $result=$this->ajax_allkey_nfo();
            break;
          case 'key_value':
            $result=$this->ajax_key_value();
            break;
          case 'validate_translation':
            $result=$this->ajax_validate_translation();
            break;
          case 'validate_all':
            $result=$this->ajax_validate_all();
            break;
          case 'apply_translation':
            $result=$this->ajax_apply_translation();
            break;
          case 'delete_key':
            $result=$this->ajax_delete_key();
            break;
          case 'langs_list':
            $result=$this->ajax_langs_list();
            break;
          case 'languages_list': 
            $result=$this->ajax_get_languages_list();
            break;
          case 'export_phase0': 
            $result=$this->ajax_export_phase0();
            break;
          case 'export_phase1':
            $result=$this->ajax_export_phase1();
            break;
          case 'export_zip':
            $result=$this->ajax_export_zip();
            break;
          case 'get_key_nfo':
            $result=$this->ajax_get_key_nfo();
            break;
          case 'translation_compare_list':
            $result=$this->ajax_translation_compare_list();
            break;
          case 'translation_compare_update':
            $result=$this->ajax_translation_compare_update();
            break;
          case 'erase':
            $result=$this->ajax_erase();
            break;
          case 'switch_tmode':
            $result=$this->ajax_switch_translator_mode();
            break;
          case 'analyze_list':
            $result=$this->ajax_analyze_list();
            break;
          case 'analyze_detail':
            $result=$this->ajax_analyze_detail();
            break;
          case 'analyze_upgrade':
            $result=$this->ajax_analyze_upgrade();
            break;
          case 'backup_restore_status':
            $result=$this->ajax_backup_restore_status();
            break;
          case 'backup_restore_dobackup':
            $result=$this->ajax_backup_restore_dobackup();
            break;
          case 'backup_restore_dorestore':
            $result=$this->ajax_backup_restore_dorestore();
            break;
          case 'translators_list': 
            $result=$this->ajax_get_translators_list();
            break;
          case 'validate_user':
            $result=$this->ajax_validate_user();
            break;
        }
        exit($result);
      }
    }



    /* ---------------------------------------------------------------------------
      status functions
    --------------------------------------------------------------------------- */


    /* 
      manage display of translator actions :
       - list
    */
    function display_status_page()
    {
      //default action if not specified into URL's page
      if(!isset($_REQUEST['action']))
      {
        $_REQUEST['action']='list';
      }

      switch($_REQUEST['action'])
      {
        case 'list':
              $this->display_list();
              break;
      }
    }

    /*
      display list page of translation and allow to :
        - view a language
        - modify a language
        - create a new language
    */
    function display_list()
    {
      global $template, $user, $page;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_list.tpl');


      $template_datas=array();

      if(!isset($_REQUEST['do_scan']))
      {
        $_REQUEST['do_scan']='n';
      }

      //make a scan of directories
      if(($this->my_config['autoscan']=='y') ||
         ($_REQUEST['do_scan']=='y'))
      {
        $disk_filesdatas=array();
        $files=$this->search_languages_files(PHPWG_ROOT_PATH."language");
        $files=array_merge($files, $this->search_languages_files(PHPWG_PLUGINS_PATH));
        foreach($files as $file)
        {
          $nfo=$this->analyze_filename($file);
          $disk_filesdatas[$nfo['filename']]=$nfo;
        }

        $base_datasfiles=$this->get_all_files();
        if(count($base_datasfiles)!=count($disk_filesdatas))
        {
          $alert_changes=true;
        }
        else
        {
          $alert_changes=false;
        }
        if(!$alert_changes)
        {
          foreach($base_datasfiles as $file)
          {
            if(isset($disk_filesdatas[$file['filename']]))
            {
              if(date('Y-m-d H:i:s', $disk_filesdatas[$file['filename']]['modified'])!=$file['file_date'])
              {
                $alert_changes=true;
              }
            }
            else
            {
              $alert_changes=true;
            }
          }
        }

        if($alert_changes)
        {
          $tabsheet_url="<i><a href='".$this->page_link."&f_tabsheet=maintenance&action=analyze' style='color:#000000;'>".l10n('g001_maintenance')."/".l10n('g001_analyze')."</a></i>";
          array_push($page['infos'], sprintf(l10n('g001_alert_changes_on_files'), $tabsheet_url));
        }
      }

      $template_datas['lang_header_cols']=array();
      $langs=$this->get_translated_languages();
      if($this->is_translator())
      {
        $translator_nfo=$this->get_translator_info();                
        if($translator_nfo['display_spoken_lang']=='y')
        {
          $tmp_langs=strtolower($translator_nfo['spoken_language'].",".$translator_nfo['native_language']);
          $i=0;
          while($i<count($langs))
          {
            if(strpos($tmp_langs, substr($langs[$i],0,2))===false)
            {
              array_splice($langs, $i, 1);
            }
            else
            {
              $i++;
            }
          }
        }
      }
      foreach($langs as $val)
      {
        $template_datas['lang_header_cols'][]=array(
          'WIDTH' => $this->my_config['bars_width']+4,
          'LABEL' => $val,
          'FLAG' => TRANSLATOR_PATH."img/".strtolower(substr($val,3,2)).".png"
        );
      }

      $tmp_lang=strtolower(implode(",", $langs));
      $template_datas['files']=array();
      $nb=0;
      $filelist=$this->make_files_list();
      foreach($filelist as $file => $nfo)
      {
        $tmp_nfo_lang=array();
        $nb++;
        $filenfo=explode(':', $file);
        foreach($nfo as $key => $val)
        {
          if(strpos($tmp_lang, substr($key,0,2))!==false)
          {
            if(count($val)>0)
            {
              $text = '';
              $width_tt = ceil($this->my_config['bars_width']*$val['nb_to_translate']/$val['nb_elem']);
              $width_tv = ceil($this->my_config['bars_width']*$val['nb_to_validate']/$val['nb_elem']);
              $width_to = ceil($this->my_config['bars_width']*$val['nb_ok']/$val['nb_elem']);
              $width_td = ceil($this->my_config['bars_width']*$val['nb_deleted']/$val['nb_elem']);
            }
            else
            {
              $text = l10n('g001_n/a');
              $width_tt = 0;
              $width_to = 0;
              $width_tv = 0;
              $width_td = 0;
            }
            $tmp_nfo_lang[]=array(
              'WIDTH_TT' => $width_tt,
              'WIDTH_TO' => $width_to,
              'WIDTH_TV' => $width_tv,
              'WIDTH_TD' => $width_td,
              'NOTHING' => $text
            );
          }
        }
        $template_datas['files'][]=array(
          'TYPE' => $filenfo[0],
          'NAME' => $filenfo[1],
          'FILE' => $filenfo[2],
          'ID' => $nb,
          'NFO_LANG' => $tmp_nfo_lang
        );
      }

      $template_datas["TRANSLATOR_TITLE"] = l10n("g001_title_status");
      $template_datas["AJAX_URL_LIST_DETAIL"] = $this->page_link.'&ajaxfct=translation_detail_list';
      $template_datas["AJAX_URL_LANGS_LIST"] = $this->page_link.'&ajaxfct=langs_list&fileid=';
      $template_datas["NBCOLS"] = (3+2*count($langs));

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }



    /* ---------------------------------------------------------------------------
      maintenance functions
    --------------------------------------------------------------------------- */

    /* 
      manage display of maintenance actions :
        - export
        - erase
    */
    function display_maintenance_page()
    {
      global $template;

      //default action if not specified into URL's page
      if(!isset($_REQUEST['action']))
      {
        $_REQUEST['action']='export';
      }

      $template->set_filename('header_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance.tpl');

      $tabsheets=new tabsheet('MAINTENANCE_TAB');
      $tabsheets->add('export',
                            l10n('g001_export'),
                            $this->page_link."&amp;f_tabsheet=maintenance&amp;action=export", ($_REQUEST['action']=='export')?true:false);
      if(!$this->is_translator())
      {
        $tabsheets->add('erase',
                            l10n('g001_erase'),
                            $this->page_link."&amp;f_tabsheet=maintenance&amp;action=erase", ($_REQUEST['action']=='erase')?true:false);
      }
      $tabsheets->add('analyze',
                            l10n('g001_analyze'),
                            $this->page_link."&amp;f_tabsheet=maintenance&amp;action=analyze", ($_REQUEST['action']=='analyze')?true:false);
      if(!$this->is_translator())      
      {
        $tabsheets->add('backup_restore',
                            l10n('g001_backup_restore'),
                            $this->page_link."&amp;f_tabsheet=maintenance&amp;action=backup_restore", ($_REQUEST['action']=='backup_restore')?true:false);
      }
      $tabsheets->assign();
      $selected_tab=$tabsheets->get_selected();

      $template_datas=array(
        'TRANSLATOR_TITLE' => l10n('g001_maintenance_title').' ['.$selected_tab['caption'].']'
      );

      switch($_REQUEST['action'])
      {
        case 'export':  //export function
              $this->display_export_page();
              break;
        case 'erase':  //prune deleted&older items 
              $this->display_erase_page();
              break;
        case 'analyze':  //analyze difference between files&database
              $this->display_analyze_page();
              break;
        case 'backup_restore':  //backup/restore of the database
              $this->display_backup_restore_page();
              break;
      }

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'header_page');
    }

    /* 
      export functionnality
    */
    function display_export_page()
    {
      global $template;

      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_export.tpl');

      $exp_sessid=date('is').chr(rand(65,90));

      $template_datas=array(
        'AJAX_URL_EXPORT_PHASE0' => $this->page_link.'&ajaxfct=export_phase0',
        'AJAX_URL_EXPORT_PHASE1' => $this->page_link.'&ajaxfct=export_phase1',
        'AJAX_URL_EXPORT_ZIP' => $this->page_link.'&ajaxfct=export_zip&f_exp_sessid='.$exp_sessid,
        'PROGRESS_BAR_MAX' => $this->my_config['progress_bar_width'],
        'EXPORT_DISABLED' => (is_adviser())?'DISABLED':'',
        'EXPORT_SESSID' => $exp_sessid,
        'files_rows' => array()
      );
      $filelist=$this->get_all_files();
      foreach($filelist as $file => $nfo)
      {
        $nfo_width_tt = ceil(0.75*$this->my_config['bars_width']*$nfo['nb_to_translate']/$nfo['nb_elem']);
        $nfo_width_tv = ceil(0.75*$this->my_config['bars_width']*$nfo['nb_to_validate']/$nfo['nb_elem']);
        $nfo_width_to = ceil(0.75*$this->my_config['bars_width']*$nfo['nb_ok']/$nfo['nb_elem']);
        $nfo_width_td = ceil(0.75*$this->my_config['bars_width']*$nfo['nb_deleted']/$nfo['nb_elem']);

        $template_datas['files_row'][]=array(
          'TYPE' => $nfo['type'],
          'NAME' => $nfo['name'],
          'FILE' => $nfo['file'],
          'ID' => $nfo['id'],
          'FLAG' => TRANSLATOR_PATH."img/".strtolower(substr($nfo['language'],3,2)).".png",
          'LANG' => $nfo['language'],
          'NFO_WIDTH_TT' => $nfo_width_tt,
          'NFO_WIDTH_TV' => $nfo_width_tv,
          'NFO_WIDTH_TO' => $nfo_width_to,
          'NFO_WIDTH_TD' => $nfo_width_td
        );
      }

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('MAINTENANCE_BODY_PAGE', 'body_page');
    }

    /*
      erase  functionnality
    */
    function display_erase_page()
    {
      global $template;

      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_erase.tpl');

      $template_datas=array(
        'AJAX_URL_ERASE' => $this->page_link.'&ajaxfct=erase',
        'DISABLED' => (is_adviser())?"disabled='disabled'":""
      );

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('MAINTENANCE_BODY_PAGE', 'body_page');
    }

    /*
      analyze functionnality
    */
    function display_analyze_page()
    {
      global $template;

      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_analyze.tpl');


      $template_datas=array(
        'AJAX_URL_DIFF_LIST' => $this->page_link.'&ajaxfct=analyze_list',
        'AJAX_URL_DIFF_DETAIL' => $this->page_link.'&ajaxfct=analyze_detail',
        'AJAX_URL_DIFF_UPGRADE' => $this->page_link.'&ajaxfct=analyze_upgrade',
      );

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('MAINTENANCE_BODY_PAGE', 'body_page');
    }

    /*
      backup/restore functionnality
    */
    function display_backup_restore_page()
    {
      global $template;

      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_backup_restore.tpl');

      $template_datas=array(
        'AJAX_URL_BACKUP_STATUS' => $this->page_link.'&ajaxfct=backup_restore_status',
        'AJAX_URL_BACKUP_DOBACKUP' => $this->page_link.'&ajaxfct=backup_restore_dobackup',
        'AJAX_URL_BACKUP_DORESTORE' => $this->page_link.'&ajaxfct=backup_restore_dorestore',
      );

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('MAINTENANCE_BODY_PAGE', 'body_page');
    }

    /* ---------------------------------------------------------------------------
      languages functions
    --------------------------------------------------------------------------- */
    /* 
      manage langs actions :
       - list languages
       - edit a lang
       - create a new lang
       - delete a lang
    */
    function display_langs_page()
    {
      global $page;

      //default action if not specified into URL's page
      if(!isset($_REQUEST['action']))
      {
        $_REQUEST['action']='list';
      }

      if(isset($_POST['submit']))
      {
        if($_REQUEST['action']=='edit')
        {
          if($this->update_language($_POST))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_modify_lang_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_modify_lang_ko'));
          }
        }

        if($_REQUEST['action']=='add')
        {
          if($this->add_language($_POST))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_add_lang_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_add_lang_ko'));
          }
        }
      }

      if(isset($_POST['submit_delete']))
      {
        if(!is_adviser())
        {
          if($this->delete_language($_POST))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_delete_lang_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_delete_lang_ko'));
          }
        }
        else
        {
          array_push($page['errors'], l10n("g001_translator_adviser_not_allowed"));
        }
      }

      switch($_REQUEST['action'])
      {
        case 'list':
              $this->display_list_languages();
              break;
        case 'edit':
              $this->display_edit_languages('edit');
              break;
        case 'add':
              $this->display_edit_languages('add');
              break;
      }
    }

    /*
      display a list of existing languages
    */
    function display_list_languages()
    {
      global $template, $user;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_langs_global.tpl');

      $template_datas=array(
        'TRANSLATOR_TITLE' => l10n('g001_langs_title'),
        'AJAX_URL_LANGUAGES_LIST' => $this->page_link.'&ajaxfct=languages_list',
        'URL_ADD_LANG' => $this->page_link.'&f_tabsheet=langs&action=add'
      );

      $template->assign('datas', $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }

    /*
      display edit page for languages
    */
    function display_edit_languages($mode = 'edit')
    {
      global $template, $user, $page;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_langs_add.tpl');

      $template_datas=array();

      $lang_nfo=array();
      if($mode=='edit')
      {
        $lang_nfo=$this->get_language_info_by_code($_REQUEST['code']);
        if(count($lang_nfo)==0)
        {
          array_push($page['errors'], l10n('g001_cannot_find_lang'));
        }

        $template_datas['edit_mode']=array(
          'COUNTRY_CODE' => $lang_nfo['country_code'],
          'LANG_CODE' => $lang_nfo['lang_code'],
          'NBFILE' => $lang_nfo['nbfile']
        );

        //button not disabled, but later may be have to add a confirm message dialog box
        //if($lang_nfo['nbfile']==0)
        if(!$this->is_translator())
        {
          $template_datas['allow_delete']="true";
        }
      }
      else
      {
        if(isset($_REQUEST['langcode']))
        {
          $lang_nfo=array(
            'lang_code' => substr($_REQUEST['langcode'],0,2),
            'name' => '',
            'country_code' => substr($_REQUEST['langcode'],3,2),
            'country' => '',
            'direction' => 'ltr',
            'zero_plural' => 'n'
          );
        }
      }

      if(count($lang_nfo)==0)
      {
        $lang_nfo=array(
          'lang_code' => 'fr',
          'name' => '',
          'country_code' => '',
          'country' => '',
          'direction' => 'ltr',
          'zero_plural' => 'n'
        );
      }

      $template_datas['TRANSLATOR_TITLE'] = l10n('g001_langs_title_edit_'.$mode);
      $template_datas['COUNTRY_CODE'] = $lang_nfo['country_code'];
      $template_datas['COUNTRY'] = $lang_nfo['country'];
      $template_datas['NAME'] = $lang_nfo['name'];
      $template_datas['DISABLED'] = ($mode=='edit')?' disabled':'';

      $template_datas['langs_row']=array();
      $prev='';
      $langs=$this->get_all_langs_list();
      foreach($langs as $lang)
      {
        if($prev!=$lang['familly'])
        {
          $prev=$lang['familly'];
          $template_datas['langs_row'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;" disabled',
            'TEXT' => '[-- '.$lang['familly'].' --]'
          );
        }

        $template_datas['langs_row'][]=array(
          'VALUE' => $lang['code'],
          'SELECTED' => (strtolower($lang_nfo['lang_code'])==strtolower($lang['code']))?' selected':'',
          'TEXT' => '('.$lang['code'].') '.$lang['name']
        );
      }

      $template_datas['countries_row']=array();
      $prev='';
      $countries=$this->get_all_countries_list('name');
      foreach($countries as $country)
      {
        if($prev!=$country['name']{0})
        {
          $prev=$country['name']{0};
          $template_datas['countries_row'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;" disabled',
            'TEXT' => '[-- '.$country['name']{0}.' --]'
          );
        }

        $flag = "style='background-image: url(".TRANSLATOR_PATH."img/".strtolower($country['code']).".png); background-position: 2px 1px; background-repeat: no-repeat; padding-left: 24px;' ";

        $template_datas['countries_row'][]=array(
          'VALUE' => $country['code'],
          'SELECTED' => (strtolower($lang_nfo['country_code'])==strtolower($country['code']))?' selected '.$flag:$flag,
          'TEXT' => '('.$country['code'].') '.$country['name']
        );
      }


      $template_datas['direction_row']=array();
      $dirs=array('ltr', 'rtl');
      foreach($dirs as $val)
      {
        $template_datas['direction_row'][]=array(
          'VALUE' => $val,
          'SELECTED' => ($lang_nfo['direction']==$val)?' selected':'',
          'TEXT' => l10n('g001_'.$val)
        );
      }

      $template_datas['zero_plural_row']=array();
      $yesno=array('y', 'n');
      foreach($yesno as $val)
      {
        $template_datas['zero_plural_row'][]=array(
          'VALUE' => $val,
          'SELECTED' => ($lang_nfo['zero_plural']==$val)?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
      }

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }




    /* ---------------------------------------------------------------------------
      translators functions
    --------------------------------------------------------------------------- */
    /* 
      manage translators actions :
       - list translators
       - edit a translator
       - create a new translator
       - delete a translator
       - show a translator
    */
    function display_translators_page()
    {
      global $page;

      //default action if not specified into URL's page
      if(!isset($_REQUEST['action']))
      {
        $_REQUEST['action']='list';
      }

      if(isset($_POST['submit']))
      {
        $nfo['id']=$_POST['f_id'];
        $nfo['country']=$_POST['f_country_code'];
        $nfo['town']=$_POST['f_town'];
        $nfo['native_language']=$_POST['f_lang_code'];
        $nfo['sex']=$_POST['f_sex'];
        $nfo['spoken_language']=$_POST['f_spoken_language'];
        $nfo['comment']=$_POST['f_comment'];
        $nfo['birthdate']=substr($_POST['f_birthdate'],6,4)."-".substr($_POST['f_birthdate'],3,2)."-".substr($_POST['f_birthdate'],0,2);
        $nfo['display_spoken_lang']=$_POST['f_display_spoken_lang'];
        $nfo['default_displayed_language']=$_POST['f_default_displayed_language'];

        if($_REQUEST['action']=='edit')
        {
          if($this->update_translator($nfo))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_modify_translator_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_modify_translator_ko'));
          }
        }

        if($_REQUEST['action']=='add')
        {
          if($this->add_translator($nfo))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_add_translator_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_add_translator_ko'));
          }
        }
      }

      if(isset($_POST['submit_delete']))
      {
        if(!is_adviser())
        {
          $nfo['id']=$_POST['f_id'];
          if($this->delete_translator($nfo))
          {
            $_REQUEST['action']='list';
            array_push($page['infos'], l10n('g001_delete_translator_ok'));
          }
          else
          {
            array_push($page['errors'], l10n('g001_delete_translator_ko'));
          }
        }
        else
        {
          array_push($page['errors'], l10n("g001_translator_adviser_not_allowed"));
        }
      }

      switch($_REQUEST['action'])
      {
        case 'list':
              $this->display_list_translators();
              break;
        case 'show':
              $this->display_show_translators('show');
              break;
        case 'edit':
              $this->display_edit_translators('edit');
              break;
        case 'add':
              $this->display_edit_translators('add');
              break;
      }
    }

    /*
      display a list of existing translators
    */
    function display_list_translators()
    {
      global $template, $user;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_translators_global.tpl');

      $template_datas=array(
        'ISNOTTRANSLATOR' => !$this->is_translator(),
        'TRANSLATOR_TITLE' => l10n('g001_translators_title'),
        'AJAX_URL_TRANSLATORS_LIST' => $this->page_link.'&ajaxfct=translators_list',
        'AJAX_URL_TRANSLATORS_VALIDATE_USER' => $this->page_link.'&ajaxfct=validate_user&user_id=',
        'URL_ADD_TRANSLATOR' => $this->page_link.'&f_tabsheet=translators&action=add'
      );

      $template->assign('datas', $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }

    /*
      display edit page for languages
    */
    function display_show_translators()
    {
      global $template, $user;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_translators_show.tpl');

      $template_datas=array();

      $nfo=$this->get_translators_info($_REQUEST['user_id']);
      if(count($nfo)==0)
      {
        array_push($page['errors'], l10n('g001_cannot_find_translator'));
      }

      $template_datas['TRANSLATOR_TITLE'] = l10n('g001_translators_title_show');
      $template_datas['NAME'] = $nfo['name'];
      $template_datas['ID'] = $nfo['id'];
      $template_datas['TOWN'] = $nfo['town'];
      $template_datas['AGE'] = $nfo['age'];
      $template_datas['COMMENT'] = $nfo['comment'];
      $template_datas['SEX'] = l10n("g001_translator_sex".strtolower($nfo['sex']));
      $template_datas['SPOKEN_LANGUAGES']=implode(", ",$this->make_spoken_languages($nfo['spoken_language']));
      $template_datas['NATIVE_LANGUAGE']=implode(", ",$this->make_spoken_languages($nfo['native_language']));
      $template_datas['FLAG'] = TRANSLATOR_PATH."img/".strtolower($nfo['country']).".png";
      $template_datas['COUNTRY'] = $this->get_formatted_country($nfo['country']);

      $template_datas['GRAPHWIDTH'] = $this->my_config['bars_width']+20;

      $template_datas['FILES']=array();
      $sql="SELECT ptf.type, ptf.name, ptf.file, ptf.language, ptf.nb_elem, count(distinct ptk.id) as nb_id, status, ptk.file_id
          FROM ".$this->tables["keys"]." ptk, ".$this->tables["files"]." ptf
          WHERE translator = '".$_REQUEST['user_id']."'
            AND ptk.file_id = ptf.id
          GROUP BY ptk.file_id, status
          ORDER BY ptf.language, ptf.type, ptf.file, status";
      $result=pwg_query($sql);
      if($result)
      {
        $key="";
        while($row=mysql_fetch_assoc($result))
        {
          if($row['type'].$row['name'].$row['file'].$row['language']!=$key)
          {
            if($key!="")
            {
              //end previous key
              $ratio = $this->my_config['bars_width']/$template_datas['FILES'][$i]['NB_TOTAL'];
              $template_datas['FILES'][$i]['WIDTH_TV'] = $template_datas['FILES'][$i]['NB_TOVALIDATE'] * $ratio;
              $template_datas['FILES'][$i]['WIDTH_TO'] = $template_datas['FILES'][$i]['NB_VALIDATED'] * $ratio;
              $template_datas['FILES'][$i]['WIDTH_TD'] = $template_datas['FILES'][$i]['NB_DELETED'] * $ratio;
              $template_datas['FILES'][$i]['WIDTH_TT'] = $this->my_config['bars_width'] - ($template_datas['FILES'][$i]['WIDTH_TV']+$template_datas['FILES'][$i]['WIDTH_TO']+$template_datas['FILES'][$i]['WIDTH_TD']);
            }

            $key=$row['type'].$row['name'].$row['file'].$row['language'];
            $template_datas['FILES'][]=array(
              'TYPE' => $row['type'],
              'NAME' => $row['name'],
              'FILE' => $row['file'],
              'FLAG' => TRANSLATOR_PATH."img/".strtolower(substr($row['language'],3,2)).".png",
              'LANGUAGE' => $row['language'],
              'NB_TOVALIDATE' => 0,
              'NB_VALIDATED' => 0,
              'NB_DELETED' => 0,
              'NB_TOTAL' => $row['nb_elem'],
              'WIDTH_TV' => 0,
              'WIDTH_TO' => 0,
              'WIDTH_TD' => 0,
              'WIDTH_TT' => 0
            );
            $i=count($template_datas['FILES'])-1;
          }
        
          if($row['status']=='valide_it')
          {
            $template_datas['FILES'][$i]['NB_TOVALIDATE']=$row['nb_id'];
          }
          elseif($row['status']=='ok')
          {
            $template_datas['FILES'][$i]['NB_VALIDATED']=$row['nb_id'];
          }
          elseif($row['status']=='deleted')
          {
            $template_datas['FILES'][$i]['NB_DELETED']=$row['nb_id'];
          }
        }

        if($key!="")
        {
          //end previous key
          $ratio = $this->my_config['bars_width']/$template_datas['FILES'][$i]['NB_TOTAL'];
          $template_datas['FILES'][$i]['WIDTH_TV'] = ceil($template_datas['FILES'][$i]['NB_TOVALIDATE'] * $ratio);
          $template_datas['FILES'][$i]['WIDTH_TO'] = ceil($template_datas['FILES'][$i]['NB_VALIDATED'] * $ratio);
          $template_datas['FILES'][$i]['WIDTH_TD'] = ceil($template_datas['FILES'][$i]['NB_DELETED'] * $ratio);
          $template_datas['FILES'][$i]['WIDTH_TT'] = $this->my_config['bars_width'] - ($template_datas['FILES'][$i]['WIDTH_TV']+$template_datas['FILES'][$i]['WIDTH_TO']+$template_datas['FILES'][$i]['WIDTH_TD']);
        }

        $template_datas['STATUSER']=(count($template_datas['FILES'])>0);

        $sql="SELECT DATEDIFF(NOW(), date)
          FROM ".$this->tables['keys']." ptk
          WHERE ptk.translator = '".$_REQUEST['user_id']."'
          ORDER BY date LIMIT 0,1";
        $result=pwg_query($sql);
        if($result)
        {
          $row=mysql_fetch_row($result);
          if($row[0]<=7)
          {
            $template_datas['ACTIVITY']=l10n('g001_translator_activity_week');
          }
          elseif($row[0]<=31)
          {
            $template_datas['ACTIVITY']=l10n('g001_translator_activity_month');
          }
          elseif($row[0]<=90)
          {
            $template_datas['ACTIVITY']=l10n('g001_translator_activity_l3month');
          }
          else
          {
            $template_datas['ACTIVITY']=l10n('g001_translator_activity_g3month');
          }
          
        }

      }
      else
      {
        $template_datas['STATUSER']=false;
      }


      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }

    /*
      display edit page for languages
    */
    function display_edit_translators($mode = 'edit')
    {
 
      global $template, $user, $page;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_translators_add.tpl');

      $template_datas=array();

      if($this->is_translator())
      {
        //to prevent hack, translator can only edit his own profile
        $mode="edit";
        $_REQUEST['user_id']=$user['id'];
      }

      $nfo=array();
      if($mode=='edit')
      {
        $nfo=$this->get_translators_info($_REQUEST['user_id']);
        if(count($nfo)==0)
        {
          array_push($page['errors'], l10n('g001_cannot_find_translator'));
        }

        if(!$this->is_translator())
        {
          //translators can't delete translator
          $template_datas['allow_delete']="true";
        }

        $template_datas['ADD_MODE'] = false;
        $template_datas['NAME'] = $nfo['name'];
        $template_datas['ID'] = $nfo['id'];
        $template_datas['TOWN'] = $nfo['town'];
        $template_datas['BIRTHDATE'] = ($nfo['birthdate']=='0000-00-00')?'':date("d/m/Y", strtotime($nfo['birthdate']));
        $template_datas['COMMENT'] = $nfo['comment'];
      }
      else
      {
        $nfo=array(
          'country' => "",
          'town' => '',
          'native_language' => "",
          'sex' => 'p',
          'birthdate' => '',
          'comment' => '',
          'spoken_language' => '',
          'display_spoken_lang' => 'y',
          'default_displayed_language' => $this->my_config['mainlang']
        );
        $template_datas['ADD_MODE'] = true;
      }

      $template_datas['TRANSLATOR_TITLE'] = l10n('g001_translators_title_edit_'.$mode);
      $template_datas['CAN_SUBMIT'] = true;

      
      $template_datas['sl_row']=array();
      $template_datas['langs_row']=array();
      $template_datas['langs2_row']=array();
      $prev='';
      $num=0;
      $langs=$this->get_all_langs_list();
      foreach($langs as $lang)
      {
        if($prev!=$lang['familly'])
        {
          $prev=$lang['familly'];
          $template_datas['langs_row'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;" disabled',
            'TEXT' => '[-- '.$lang['familly'].' --]'
          );
          $template_datas['langs2_row'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;" disabled',
            'TEXT' => '[-- '.$lang['familly'].' --]'
          );
          $num++;
        }

        $template_datas['langs_row'][]=array(
          'VALUE' => $lang['code'],
          'SELECTED' => (strtolower($nfo['native_language'])==strtolower($lang['code']))?' selected':'',
          'TEXT' => '('.$lang['code'].') '.$lang['name']
        );


        if(strpos($nfo['spoken_language'], $lang['code'])!==false)
        {
          $template_datas['sl_row'][]=array(
            'VALUE' => $lang['code'],
            'SELECTED' => '',
            'TEXT' => '('.$lang['code'].') '.$lang['name'],
            'ID' => 'sli_'.$num
          );
          $lang2disabled=" disabled";
        }
        else
        {
          $lang2disabled="";
        }
        $template_datas['langs2_row'][]=array(
          'VALUE' => $lang['code'],
          'SELECTED' => $lang2disabled,
          'TEXT' => '('.$lang['code'].') '.$lang['name']
        );

        $num++;
      }

      $template_datas['countries_row']=array();
      $prev='';
      $countries=$this->get_all_countries_list('name');
      foreach($countries as $country)
      {
        if($prev!=$country['name']{0})
        {
          $prev=$country['name']{0};
          $template_datas['countries_row'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;" disabled',
            'TEXT' => '[-- '.$country['name']{0}.' --]'
          );
        }

        $flag = "style='background-image: url(".TRANSLATOR_PATH."img/".strtolower($country['code']).".png); background-position: 2px 1px; background-repeat: no-repeat; padding-left: 24px;' ";


        $template_datas['countries_row'][]=array(
          'VALUE' => $country['code'],
          'SELECTED' => (strtolower($nfo['country'])==strtolower($country['code']))?' selected '.$flag:$flag,
          'TEXT' => '('.$country['code'].') '.$country['name']
        );
      }


      $template_datas['sex_row']=array();
      $sexes=array('P', 'F', 'M');
      foreach($sexes as $sex)
      {
        $template_datas['sex_row'][]=array(
          'VALUE' => $sex,
          'SELECTED' => ($nfo['sex']==$sex)?' selected':'',
          'TEXT' => l10n('g001_translator_sex'.strtolower($sex))
        );
      }

      $template_datas["display_spoken_lang_row"]=array();
      $yesno=array('y', 'n');
      foreach($yesno as $key => $val)
      {
        $template_datas["display_spoken_lang_row"][]=array(
          'VALUE' => $val,
          'SELECTED' => ($val==$nfo['display_spoken_lang'])?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
      }

      $translated_langs=$this->get_translated_languages();
      $template_datas["default_displayed_language_row"]=array();
      foreach($translated_langs as $key => $val)
      {
        $template_datas["default_displayed_language_row"][]=array(
          'VALUE' => $val,
          'SELECTED' => ($val==$nfo['default_displayed_language'])?' selected':'',
          'TEXT' => $val
        );
      }


      if($mode=='add')
      {
        $prev='';
        $sql="SELECT pu.id, pu.username, pui.status, pui.adviser 
            FROM ".USERS_TABLE." pu, ".USER_INFOS_TABLE." pui
            WHERE pu.id = pui.user_id 
              AND pu.id NOT IN (SELECT id FROM ".$this->tables['users'].") 
              AND pui.status <> 'guest'
            ORDER BY status, username";
        $result=pwg_query($sql);
        $template_datas['users_id']=array();
        if($result)
        {
          while($row=mysql_fetch_assoc($result))
          {
            if($prev!=$row['status'])
            {
              $prev=$row['status'];
              $template_datas['users_id'][]=array(
                'VALUE' => '',
                'SELECTED' => 'style="font-weight:bold;" disabled',
                'TEXT' => '[-- '.l10n($row['status']).' --]'
              );
            }

            $template_datas['users_id'][]=array(
              'VALUE' => $row['id'], 
              'TEXT' => ($row['adviser']=='true')?$row['username'].' ('.l10n('adviser').')':$row['username'], 
              'SELECTED' => ''
            );
          }
        }

        if(count($template_datas['users_id'])==0)
        {
          $template_datas['users_id'][]=array(
            'VALUE' => '',
            'SELECTED' => 'style="font-weight:bold;"',
            'TEXT' => '[-- '.l10n('g001_no_user_to_affect').' --]'
          );
          $template_datas['CAN_SUBMIT'] = false;
        }
      }


      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }






    /* ---------------------------------------------------------------------------
      translation edit functions
    --------------------------------------------------------------------------- */

    /* 
      manage editing actions :
       - compare translation
       - edit a translation
       - create a new language from another (translate to)
    */
    function display_editing_page()
    {
      //default action if not specified into URL's page
      if(!isset($_REQUEST['action']))
      {
        $_REQUEST['action']='none';
      }

      switch($_REQUEST['action'])
      {
        case 'none':
              //$this->display_unknow_action();
              break;
        case 'compare_lang':
              $this->display_comparefiles_action($_REQUEST['fname'],$_REQUEST['ftype'],$_REQUEST['ffile']);
              break;
        case 'edit':
              $this->display_edit_action($_REQUEST['fileid']);
              break;
        case 'editkey':
              $this->display_editkey_action($_REQUEST['key']);
              break;
        case 'translateto':
              $this->display_translateto_action($_REQUEST['fileid']);
              break;
      }
    }

    /*
      display translation edit page of a file
    */
    function display_edit_action($file_id, $page=1, $displaykey='')
    {
      global $template, $user;
      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_global.tpl');

      $nfo=$this->get_file_info_by_id($file_id);
      $langs='';
      foreach($nfo['langs'] as $lang)
      {
        $langs.=$lang['language'].'<br/>';
      }

      $template_datas=array(
        'NFO_TYPE' => $nfo['type'],
        'NFO_NAME' => $nfo['name'],
        'NFO_VERSION' => $nfo['version'],
        'NFO_FILE' => $nfo['file'],
        'NFO_LANGS' => $langs,
        'NFO_LANG' => $nfo['language'],
        'FLAG' => TRANSLATOR_PATH."img/".strtolower(substr($nfo['language'],3,2)).".png",
        'TOLANG' => substr($nfo['language'], 0, 2),
        'AJAX_URL_FILE_NFO' => $this->page_link.'&ajaxfct=file_nfo&fileid='.$file_id,
        'AJAX_URL_EDIT_LIST' => $this->page_link.'&ajaxfct=load_edit_list&fileid='.$file_id.'&fpage=',
        'AJAX_URL_EDIT_LIST_ALLDETAIL' => $this->page_link.'&ajaxfct=allkey_nfo&fileid='.$file_id.'&fto='.substr($nfo['language'], 0, 2),
        'AJAX_URL_EDIT_LIST_DETAIL' => $this->page_link.'&ajaxfct=key_nfo&fileid='.$file_id.'&fkey=',
        'AJAX_URL_TRANSLATION_MODEL' => $this->page_link.'&ajaxfct=key_value&translatelnk=y&fto='.substr($nfo['language'], 0, 2).'&fileid=',
        'AJAX_URL_VALIDATE_TRANSLATION' => $this->page_link.'&ajaxfct=validate_translation&fileid='.$file_id.'&fkey=',
        'AJAX_URL_VALIDATE_ALL' => $this->page_link.'&ajaxfct=validate_all&fileid='.$file_id,
        'AJAX_URL_APPLY_TRANSLATION' => $this->page_link.'&ajaxfct=apply_translation&fileid='.$file_id.'&fkey=',
        'AJAX_URL_DELETE_KEY' => $this->page_link.'&ajaxfct=delete_key&fileid='.$file_id.'&fkey=',
        'TRANSLATOR_TITLE' => sprintf(l10n('g001_file_translate_gui'), $nfo['name'].'/'.$nfo['file'].'/'.$nfo['language'], l10n('g001_file_translate_gui_editkey')),
        'DISPLAYKEY' => $displaykey,
        'PAGE' => $page,
        'status_filters' => array(),
        'status_filters2' => array()
      );

      foreach($this->statuslist as $key => $val)
      {
        $template_datas['status_filters'][]=array(
          'VALUE' => $key,
          'SELECT' => ($key==$this->my_config['default_status_filter'])?' selected':'',
          'TEXT' => l10n($val)
        );
      }

      $template_datas['status_filters2'][]=array(
        'VALUE' => '0',
        'SELECT' => '', //($key==$this->my_config['default_status_filter'])?' selected':'',
        'TEXT' => l10n($this->statuslist['none'])
      );
      $translator_list=$this->get_translators_list();
      foreach($translator_list as $key => $val)
      {
        $template_datas['status_filters2'][]=array(
          'VALUE' => $val['id'],
          'SELECT' => '', //($key==$this->my_config['default_status_filter'])?' selected':'',
          'TEXT' => l10n($val['name'])
        );
      }
      

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }


    /*
      display translation edit page of a file
    */
    function display_editkey_action($uindex)
    {
      $nfo=$this->get_key_nfo_by_unique_index($uindex);
      $page=$this->find_key_page($nfo['id'], $nfo['file_id']);
      $this->display_edit_action($nfo['file_id'], $page, $nfo['id']);
    }

    /*
      display compare page of a file
    */
    function display_comparefiles_action($name, $type, $file)
    {
      global $template, $user;

      $template->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_compare.tpl');

      $template_datas=array(
        'AJAX_URL_EDIT_COMPARE_LIST' => $this->page_link.'&ajaxfct=translation_compare_list&fname='.$name.'&ftype='.$type.'&ffile='.$file,
        'AJAX_URL_EDIT_COMPARE_UPDATE' => $this->page_link.'&ajaxfct=translation_compare_update&fname='.$name.'&ftype='.$type.'&ffile='.$file,
        'NFO_TYPE' => $type,
        'NFO_NAME' => $name,
        'NFO_FILE' => $file,
        'TRANSLATOR_TITLE' => sprintf(l10n('g001_file_translate_gui'), $name."/".$file, l10n("g001_file_translate_gui_compare"))
      );

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }

    /*
      display create new translation page of a file
    */
    function display_translateto_action($file_id)
    {
      if($this->is_translator())
      {
        $this->display_result(l10n("g001_translator_not_allowed"), false);
        return(false);
      }
      elseif(is_adviser())
      {
        $this->display_result(l10n("g001_translator_adviser_not_allowed"), false);
        return(false);
      }

      $result=$this->duplicate_file($file_id, $_REQUEST['flang']);
      if($result>0)
      {
        $this->display_edit_action($result);
      }
      else
      {

      }
    }


    /* ---------------------------------------------------------------------------
      config functions
    --------------------------------------------------------------------------- */


    /*
      manage display of config page & save config
    */
    function display_config_page()
    {
      $languages=get_languages();
      if(isset($_POST['submit_save_config']))
      {
        if(!$this->adviser_abort())
        {
          // have to take a look about this code, keeped for reminding until rewritted
          foreach($this->my_config as $key => $val)
          {
            if(isset($_REQUEST['f_translator_'.$key]))
            {
              $this->my_config[$key] = $_REQUEST['f_translator_'.$key];
            }

          }
          $this->display_result(l10n('g001_save_config'), $this->save_config());
        
        }
      }
      $this->display_config();
    }


    /*
      display config page
    */
    function display_config()
    {
      global $template;

      $template->set_filename('body_page',
                  dirname($this->filelocation).'/admin/plugin_admin_config.tpl');



      $template_datas=array(
        "TRANSLATOR_TITLE" => l10n('g001_title_config'),
        "TRANSLATOR_CFG_BARS_WIDTH" => $this->my_config['bars_width'],
        "TRANSLATOR_CFG_COLOR_BARS4" => $this->my_config['color_bars4'],
        "TRANSLATOR_CFG_COLOR_BARS3" => $this->my_config['color_bars3'],
        "TRANSLATOR_CFG_COLOR_BARS2" => $this->my_config['color_bars2'],
        "TRANSLATOR_CFG_COLOR_BARS1" => $this->my_config['color_bars1'],
        "TRANSLATOR_CFG_MOUSEOVERCOLOR" => $this->my_config['mouse_over_color'],
        "TRANSLATOR_CFG_NUMBER_OF_ITEMS" => $this->my_config['number_of_items'],
        "TRANSLATOR_CFG_EXPORT_MAXIMUM_ITEMS" => $this->my_config['export_maximum_items'],
        "default_status_filter_row" => array(),
        "autoscan_row" => array(),
        "canregister_row" => array(),
        "need_admin_to_be_registered_row" => array()
      );

      foreach($this->statuslist as $key => $val)
      {
        $template_datas["default_status_filter_row"][]=array(
          'VALUE' => $key,
          'SELECT' => ($key==$this->my_config['default_status_filter'])?' selected':'',
          'TEXT' => l10n($val)
        );
      }

      $yesno=array('y', 'n');
      foreach($yesno as $key => $val)
      {
        $template_datas["autoscan_row"][]=array(
          'VALUE' => $val,
          'SELECT' => ($val==$this->my_config['autoscan'])?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
        $template_datas["canregister_row"][]=array(
          'VALUE' => $val,
          'SELECT' => ($val==$this->my_config['translator_canregister'])?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
        $template_datas["need_admin_to_be_registered_row"][]=array(
          'VALUE' => $val,
          'SELECT' => ($val==$this->my_config['translator_need_admin_to_be_registered'])?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
        $template_datas["mail_to_admin_row"][]=array(
          'VALUE' => $val,
          'SELECT' => ($val==$this->my_config['mail_to_admin'])?' selected':'',
          'TEXT' => l10n('g001_yesno_'.$val)
        );
      }

      $template->assign("datas", $template_datas);
      $template->assign_var_from_handle('TRANSLATOR_BODY_PAGE', 'body_page');
    }












    /* ---------------------------------------------------------------------------
      base functions
    --------------------------------------------------------------------------- */

    /*
      make sql column for compare list request (display_comparefiles_action function)
    */
    function make_compare_columns($num, $nbcolumn)
    {
      $returned = array();
      for($i=0;$i<$nbcolumn;$i++)
      {
        if($i==$num)
        {
          array_push($returned, "status as fileid".$i);
        }
        else
        {
          array_push($returned, "'' as fileid".$i);
        }
      }
      return (implode(",", $returned));
    }


    /*
      make a list of array item
    */
    function make_compare_listfile($i, $list)
    {
      $returned=array();
      for($k=0;$k<count($list);$k++)
      {
        array_push($returned, $list[$k][0]);
      }
      $returned = array_splice($returned, $i, 1);
      return (implode(",", $returned));
    }


    /*
      load a $lang file, and give an array of strings
    */
    function load_lang_file($filename)
    {
      $returned=array();
      $fhandle=fopen($filename, 'r');
      if($fhandle)
      {
        $data=fread($fhandle, filesize($filename));
        fclose($fhandle);
      }
    }


    /*
      duplicate a file : create all keys with status 'not_translated' and returns fileid of new file
    */
    function duplicate_file($file_id, $newlang)
    {
      $sql="INSERT INTO ".$this->tables['files']."
            (type, file, language, version, name, filename, nb_elem)
            SELECT type, file, '".$newlang."' as language, version, name, REPLACE(filename, language, '".$newlang."'), nb_elem
            FROM ".$this->tables['files']."
            WHERE id = '".$file_id."' ";
      $result=pwg_query($sql);
      if($result)
      {
        $newid=mysql_insert_id();
        $sql="INSERT INTO ".$this->tables['keys']."
              (id, file_id, version, date, translator, status, translation, uniqueindex)
              SELECT t0.id, '".$newid."', '1', '".date('Y-m-d H:i:s')."', '1', 'not_translated', t0.translation, MD5(CONCAT(t0.id,'-','".$newid."'))
              FROM ".$this->tables['keys']." t0
              WHERE t0.file_id = '".$file_id."'
                AND version IN
                    (
                      SELECT max(tmp.version) FROM ".$this->tables['keys']." tmp
                      WHERE tmp.id = t0.id
                        AND tmp.file_id = t0.file_id
                      GROUP BY tmp.id
                    )";
        $result=pwg_query($sql);
        if($result)
        {
          $this->update_file_counter($newid);
          return($newid);
        }
      }
      return(0);
    }


    /*
      returns translated languages
    */
    function get_translated_languages($lowercase=false)
    {
      $returned=array();

      $sql="SELECT code FROM ".$this->tables['langs']."
            ORDER BY code";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_row($result))
        {
          if($lowercase) { $row[0] = strtolower($row[0]); }
          array_push($returned, $row[0]);
        }
      }
      return($returned);
    }

    /*
      returns translated files
    */
    function get_translated_files()
    {
      $returned=array();
      $sql="SELECT DISTINCT type, name, file FROM ".$this->tables['files']."
            ORDER BY type, name, file";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row);
        }
      }
      return($returned);
    }

    /*
      returns all files
    */
    function get_all_files()
    {
      $returned=array();
      $sql="SELECT * FROM ".$this->tables['files']."
            ORDER BY type, name, file, language";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row);
        }
      }
      return($returned);
    }


    /*
      returns file list of translation by language
    */
    function make_files_list()
    {
      $returned=array();

      $langs=$this->get_translated_languages();
      $files=$this->get_translated_files();

      foreach($files as $file)
      {
        foreach($langs as $lang)
        {
          $returned[$file['type'].":".$file['name'].":".$file['file']][$lang]=array();
        }
      }

      foreach($langs as $lang)
      { 
        $sql="SELECT * FROM ".$this->tables['files']."
              WHERE language = '".$lang."'
              ORDER BY type, file, version
        ";
        $result=pwg_query($sql);
        if($result)
        {
          while($row=mysql_fetch_assoc($result))
          {
           $returned[$row['type'].":".$row['name'].':'.$row['file']][$lang]= $row;
          }
        }
      }
      return($returned);
    }

    /*
      return nfo about a translated file referenced by his id
    */
    function get_file_info_by_id($id)
    {
      $returned=array();
      $sql="SELECT * FROM ".$this->tables['files']."
            WHERE id = '".$id."'";

      $result=pwg_query($sql);
      if($result)
      {
        $returned=mysql_fetch_assoc($result);
        $returned['langs']=array();

        $sql="SELECT language, id FROM ".$this->tables['files']."
              WHERE file = '".$returned['file']."'
                AND type = '".$returned['type']."'
                AND name = '".$returned['name']."'
              ORDER BY language";
        $result=pwg_query($sql);
        if($result)
        {
          while($row=mysql_fetch_assoc($result))
          {
            array_push($returned['langs'], $row);
          }
        }
      }
      return($returned);
    }


    /*
      return nfo about a translated file
      if $lang not given, return nfo about all languages
    */
    function get_file_info($type, $name, $filename, $lang="")
    {
      $returned=array();
      $sql="SELECT * FROM ".$this->tables['files']."
            WHERE file = '".$filename."'
              AND type = '".$type."'
              AND name = '".$name."' ";
      if($lang!="")
      {
        $sql.=" AND language = '".$lang."' ";
      }
      $sql.="ORDER BY language";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          $returned[$row['language']]=$row;
        }
      }
      return($returned);
    }

    /*
      just returns the keys list of a file (associate status of key)
    */
    function get_language_file_key_list($file_id)
    {
      $return=array();
      $sql="SELECT DISTINCT id, status
            FROM ".$this->tables['keys']."
            WHERE file_id = '".$file_id."'";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          $return[$row['id']]=$row['status'];
        }
      }
      return($return);
    }

    /*
      update file date time in databse (after export or import...)
      $nfo is an array with 'id' and 'filename' items
    */
    function update_date_file($nfo, $reset=false)
    {
      if($reset)
      {
        $sql="UPDATE ".$this->tables['files']."
              SET file_date='0000-00-00 00:00:00'
              WHERE id=".$nfo['id'];
      }
      else
      {
        clearstatcache();
        $sql="UPDATE ".$this->tables['files']."
              SET file_date='".date('Y-m-d H:i:s',filemtime($nfo['filename']))."'
              WHERE id=".$nfo['id'];
      }

      $result=pwg_query($sql);
      if($result)
      {
        return(true);
      }
      return(false);
    }

    /*
      returns a list (each item is an array) of file's items
      work with $page, number of items per page is given by my_config['number_of_items'] value
      status values :
        '' : no filter
        'ok' 
        'valide_it'
        'not_translated'      
    */
    function get_language_file_items($file_id, $status, $translator, $page)
    {
      if($translator=='0')
      {
        $translator_filter="";
      }
      else
      { 
        $translator_filter=" AND tmp.id IN (
          SELECT DISTINCT id 
          FROM ".$this->tables['keys']." 
          WHERE file_id = '".$file_id."' AND (
            translator = '".$translator."' OR
            validate_by = '".$translator."' 
          )
        )";
      }

      $returned['list']=array();
      $returned['pages']=1;
      $sql="SELECT SQL_CALC_FOUND_ROWS * FROM ".$this->tables['keys']." t0
            WHERE file_id = '".$file_id."'
              AND version in
            (
              SELECT max(tmp.version) FROM ".$this->tables['keys']." tmp
              WHERE tmp.id = t0.id
                AND tmp.file_id = t0.file_id ".$translator_filter."
              GROUP BY tmp.id
            ) ";

      if($status!='')
      {
        $sql.=" AND status = '".$status."'";
      }
      $sql.=" ORDER by id ASC
              LIMIT ".(($page-1)*$this->my_config['number_of_items']).", ".$this->my_config['number_of_items'];

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned['list'], $row);
        }

        $sql="select FOUND_ROWS()";
        $result=pwg_query($sql);
        if($result)
        {
          $row=mysql_fetch_row($result);
          $returned['pages']=$row[0];
        }

      }
      return($returned);
    }

    /*
      return page number for a key
    */
    function find_key_page($key, $file_id)
    {
      $returned=1;
      $sql="SELECT id FROM ".$this->tables['keys']." t0
            WHERE file_id = '".$file_id."'
              AND version in
            (
              SELECT max(tmp.version) FROM ".$this->tables['keys']." tmp
              WHERE tmp.id = t0.id
                AND tmp.file_id = t0.file_id
              GROUP BY tmp.id
            )
            ORDER by id ASC";
      $result=pwg_query($sql);
      if($result)
      {
        $list=array();
        $i=1;
        while($row=mysql_fetch_row($result))
        {
          $list[$row[0]]=$i;
          $i++;
        }
        if(isset($list[$key]))
        {
          $returned=ceil($list[$key]/$this->my_config['number_of_items']);
        }
      }
      return($returned);
    }


    /*
      returns information about a key
        first elem : higher version
    */
    function get_key_nfo($fileid, $key)
    {
      $returned=array();
      $sql="SELECT ".$this->tables['keys'].".*, t2.username as validate_by_name, t1.username as create_by_name
            FROM  (".$this->tables['keys']."
                    LEFT OUTER JOIN ".USERS_TABLE." t1
                    ON ".$this->tables['keys'].".translator = t1.id
                  )
                    LEFT OUTER JOIN ".USERS_TABLE." t2
                    ON ".$this->tables['keys'].".validate_by = t2.id
            WHERE ".$this->tables['keys'].".file_id = '".$fileid."'
              AND ".$this->tables['keys'].".id = '".$key."'
            ORDER BY ".$this->tables['keys'].".version DESC";

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row);
        }
      }
      return($returned);
    }


    /*
      returns information about a key
    */
    function get_key_nfo_by_unique_index($uniqueindex)
    {
      $returned=array();
      $sql="SELECT ".$this->tables['keys'].".*,
                    t2.username as validate_by_name, t1.username as create_by_name,
                    t3.type, t3.file, t3.language, t3.name, t3.file_date
            FROM  (".$this->tables['keys']."
                    LEFT OUTER JOIN ".USERS_TABLE." t1
                    ON ".$this->tables['keys'].".translator = t1.id
                  )
                  LEFT OUTER JOIN ".USERS_TABLE." t2
                  ON ".$this->tables['keys'].".validate_by = t2.id,
                  ".$this->tables['files']." t3
            WHERE ".$this->tables['keys'].".uniqueindex = '".$uniqueindex."'
              AND ".$this->tables['keys'].".file_id = t3.id
            ORDER BY ".$this->tables['keys'].".version DESC LIMIT 0,1 ";

      $result=pwg_query($sql);
      if($result)
      {
        $returned=mysql_fetch_assoc($result);
      }
      return($returned);
    }

    /*
      change status value for a key
    */
    function change_key_status($fileid, $key, $version, $validateby, $status)
    {
      $sql='UPDATE '.$this->tables['keys'].' t0,
                   (SELECT max(t1.version) as maxversion, t1.id, t1.file_id
                    FROM '.$this->tables['keys'].' t1
                    GROUP BY t1.id, t1.file_id
                   ) t2 
            SET t0.status = "'.$status.'",
                t0.validate_by = "'.$validateby.'",
                t0.validate_date = "'.date('Y-m-d H:i:s').'"
            WHERE t0.file_id = "'.$fileid.'" ';

      if($key!='')
      {
        $sql.=' AND t0.id = "'.$key.'" ';
      }
      else
      {
        $sql.=' AND t0.status = "valide_it" ';
      }

      if($version!='')
      {
        $sql.=' AND t0.version = "'.$version.'" ';
      }
      else
      {
        $sql.=' AND t0.version = t2.maxversion
                AND t0.id = t2.id
                AND t0.file_id = t2.file_id';
      }

      $result=pwg_query($sql);
      if($result)
      {
        $result=$this->update_file_counter($fileid);
        $result=pwg_query($sql);
        if($result)
        {
          return(true);
        }
      }
      return(false);
    }

    /*
      insert a new translation for a key
    */
    function insert_key_translation($fileid, $key, $createdby, $value, $status='valide_it')
    {
      $sql="SELECT t1.version, t0.status 
            FROM ".$this->tables['keys']." t0,
                  (
                    SELECT max(version) as version FROM ".$this->tables['keys']."
                    WHERE id = '".$key."'
                      AND file_id = '".$fileid."'
                  ) t1
            WHERE t0.id = '".$key."'
              AND t0.file_id = '".$fileid."'
              AND t0.version = t1.version";
      $result=pwg_query($sql);
      if($result)
      {
        $nextversion=mysql_fetch_row($result);
        if(($nextversion[0]==1)&&($nextversion[1]=='not_translated'))
        {
          $sql="UPDATE ".$this->tables['keys']."
                SET status = '".$status."',
                    translator = '".$createdby."',
                    date = '".date("Y-m-d H:i:s")."',
                    translation = '".addslashes($value)."'
                WHERE id = '".$key."'
                  AND file_id = '".$fileid."'
                  AND version = '1'";
        }
        else//
        {
          $sql="INSERT INTO ".$this->tables['keys']." VALUES(
            '".$key."',
            '".$fileid."',
            '".($nextversion[0]+1)."',
            '".date("Y-m-d H:i:s")."',
            '".$createdby."',
            '".$status."',
            '".addslashes($value)."',
            '0',
            '0000-00-00 00:00:00',
            '".$this->calculate_uniquekey($key, $fileid)."'
          )";
        }
        $result=pwg_query($sql);
        if($result)
        {
          $result=$this->update_file_counter($fileid);
          if($result)
          {
            return(true);
          }
        }
      }
      return(false);
    }


    function delete_key($fileid, $key, $deleted_by)
    {
      $sql="SELECT t1.id 
            FROM (".$this->tables['files']." t1
                  LEFT OUTER JOIN ".$this->tables['files']." t2
                  ON t1.type = t2.type
                  AND t1.file = t2.file
                  AND t1.name=t2.name
                 )
                  LEFT OUTER JOIN ".$this->tables['keys']." t3
                  ON t3.file_id = t1.id
            WHERE t2.id = '".$fileid."'
              AND t3.id = '".$key."';";
      $result=pwg_query($sql);
      if(!$result)
      {
        return(false);
      }
      $fileids=array();
      while($row=mysql_fetch_array($result))
      {
        array_push($fileids, $row[0]);
      }
      
      $sql="UPDATE ".$this->tables['keys']."
            SET status = 'deleted'
            WHERE file_id in (".implode(',', $fileids).")
              AND id = '".$key."'";
      $result=pwg_query($sql);
      if($result)
      {
        $result=$this->update_file_counter($fileids);
        if($result)
        {
          return(true);
        }
      }
      return(false);
    }

    function update_file_counter($fileid='')
    {
      $sql="UPDATE ".$this->tables['files']." tr,
            (SELECT SUM(cok) AS ok,
                    SUM(cvalide_it) AS valide_it,
                    SUM(cto_translate) AS to_translate,
                    SUM(cdeleted) AS deleted,
                    (SUM(cok)+SUM(cvalide_it)+SUM(cto_translate)+SUM(cdeleted)) as nbelem,
                    ts.file_id AS file_id
            FROM (SELECT t0.file_id,
                          IF(status='ok', COUNT(status), 0) AS 'cok',
                          IF(status='valide_it', COUNT(status), 0) AS 'cvalide_it',
                          IF(status='not_translated', COUNT(status), 0) AS 'cto_translate',
                          IF(status='deleted', COUNT(status), 0) AS 'cdeleted'
                  FROM ".$this->tables['keys']." t0
                  WHERE t0.version IN
                                      (
                                        SELECT max(tmp.version)
                                        FROM ".$this->tables['keys']." tmp
                                        WHERE tmp.id = t0.id
                                          AND tmp.file_id = t0.file_id
                                        GROUP BY tmp.id
                                      )
                  GROUP BY file_id,status
                 ) AS ts
            GROUP BY ts.file_id
            ) AS tsum

            SET tr.nb_ok = tsum.ok,
                tr.nb_deleted = tsum.deleted,
                tr.nb_to_validate = tsum.valide_it,
                tr.nb_to_translate = tsum.to_translate,
                tr.nb_elem = tsum.nbelem
            WHERE tsum.file_id = tr.id ";
      if(is_array($fileid))
      {
        $sql.=" and tr.id in (".implode(',', $fileid).")";
      }
      elseif($fileid!='')
      {
        $sql.=" and tr.id = '".$fileid."' ";
      }
      $result=pwg_query($sql);
      if($result)
      {
        return(true);
      }
      return(false);
    }


    /*
      returns countries list from countries_codes table
    */
    function get_all_countries_list($orderby='code')
    {
      $returned=array();
      $sql="SELECT * FROM ".$this->tables['countries_codes']."
            ORDER BY ".$orderby;

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row);
        }
      }
      return($returned);
    }

    /*
      returns a formatted name for a country
        FR =>   France(FR)
        ES =>   Spain(ES)
    */
    function get_formatted_country($country)
    {
      if($country=="")
      {
        return("");
      }
      $returned="(".$country.")";
      $sql="SELECT * FROM ".$this->tables['countries_codes']."
            WHERE code = '".$country."'
            ORDER BY code";

      $result=pwg_query($sql);
      if($result)
      {
        if($row=mysql_fetch_assoc($result))
        {
          $returned=ucfirst(strtolower($row['name'])).$returned;
        }
      }
      return($returned);
    }

    /*
      returns langs list from langs table
    */
    function get_langs_list()
    {
      $returned=array();
      $sql="SELECT t0.*,
                    ".$this->tables['langs_codes'].".name as isoname,
                    ".$this->tables['langs_codes'].".familly as isofamilly,
                    count(t1.id) as nbfile
            FROM (".$this->tables['langs']." t0
              LEFT OUTER JOIN ".$this->tables['langs_codes']."
              ON t0.lang_code = ".$this->tables['langs_codes'].".code)
                LEFT OUTER JOIN ".$this->tables['files']." t1
                ON t1.language = t0.code
            GROUP BY t0.code
            ORDER BY ".$this->tables['langs_codes'].".familly,
                     ".$this->tables['langs_codes'].".name ";

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          $returned[$row['code']]=$row;
        }
      }
      return($returned);
    }

    /*
      returns langs list from langs_code table
    */
    function get_all_langs_list()
    {
      $returned=array();
      $sql="SELECT * FROM ".$this->tables['langs_codes']."
            ORDER BY familly, name";

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        {
          array_push($returned, $row);
        }
      }
      return($returned);
    }

    /*
      return info about a lang referenced into langs table
        search by 'code' (eg. en_UK.iso-8859-1)


      ========> in root class
    */

    /*
      insert a new lang into 'langs' table
        $nfo is an array
    */
    function add_language($nfo)
    {
      $sql="INSERT INTO ".$this->tables['langs']." VALUES (
        '".strtolower($nfo['f_lang_code'])."',
        '".strtoupper($nfo['f_country_code'])."',
        '".$nfo['f_direction']."',
        '".$nfo['f_name']."',
        '".$nfo['f_country']."',
        '".$nfo['f_zero_plural']."',
        '".strtolower($nfo['f_lang_code']).'_'.strtoupper($nfo['f_country_code'])."'
      )";
      $result=pwg_query($sql);
      if($result)
      {
        return(true);
      }
      return(false);
    }

    /*
      modify a lang from 'langs' table
        $nfo is an array
    */
    function update_language($nfo)
    {
      $sql="UPDATE ".$this->tables['langs']."
            SET direction = '".$nfo['f_direction']."',
                name = '".$nfo['f_name']."',
                country = '".$nfo['f_country']."',
                zero_plural = '".$nfo['f_zero_plural']."'
            WHERE lang_code = '".$nfo['f_lang_code']."'
              AND country_code = '".$nfo['f_country_code']."' ";
      $result=pwg_query($sql);
      if($result)
      {
        return(true);
      }
      return(false);
    }

    /*
      delete a lang from 'langs' table, 'files' table and 'keys' table
        $nfo is an array
    */
    function delete_language($nfo)
    {
      $sql="DELETE FROM ".$this->tables['langs']."
            WHERE lang_code = '".$nfo['f_lang_code']."'
              AND country_code = '".$nfo['f_country_code']."' ";
      $result=pwg_query($sql);
      if($result)
      {
        $language = $nfo['f_lang_code']."_".$nfo['f_country_code'];
        $sql="DELETE FROM ".$this->tables['keys']."
              WHERE file_id IN
                (SELECT id FROM ".$this->tables['files']." WHERE language='".$language."')";
        $result=pwg_query($sql);
        if($result)
        {
          $sql="DELETE FROM ".$this->tables['files']."
                WHERE language='".$language."'";
          $result=pwg_query($sql);
          if($result)
          {
            return(true);
          }
        }
      }
      return(false);
    }

    /*
      return true if user is a translator, otherwise false
        ===========> defined in root class
    */
    // function is_translator()


    /*
      returns translators list from translators table
        ===========> defined in root class
    */
     // function get_translators_list($user_id="")
    
    /*
      return info about a translator referenced into translators table
        ===========> defined in root class
    */
    //  function get_translators_info($user_id)


    /*
      insert a new lang into 'langs' table
        $nfo is an array

      =======> declaration in root class
    */
    //  function add_translator($nfo)

    /*
      modify a translator from 'translators' table
        $nfo is an array
    */
    function update_translator($nfo)
    {
      global $user, $page;
      if(is_adviser())
      {
        if($this->is_translator())
        {
          if($user['id']!=$nfo['id'])
          {
            // a translator can't modify nfo of another translator
            return(false);
          }
        }
        else
        {
          // if adviser without being a translator, can't modify nfo
          $this->adviser_abort();
          return(false);
        }
      }
      

      $sql="UPDATE ".$this->tables['users']."
            SET country = '".$nfo['country']."',
                town = '".$nfo['town']."',
                native_language = '".$nfo['native_language']."',
                sex = '".$nfo['sex']."',
                birthdate = '".$nfo['birthdate']."',
                comment = '".$nfo['comment']."',
                display_spoken_lang = '".$nfo['display_spoken_lang']."',
                default_displayed_language = '".$nfo['default_displayed_language']."'
            WHERE id = '".$nfo['id']."'";

      $result=pwg_query($sql);
      if($result)
      {
        $sql="DELETE FROM ".$this->tables['users_langs']." WHERE id = '".$nfo['id']."'";
        $result=pwg_query($sql);
        if($result)
        {
          $tmp=explode(",", $nfo['spoken_language']);
          foreach($tmp as $key => $val)
          {
            $sql="INSERT INTO ".$this->tables['users_langs']." VALUES (
              '".$nfo['id']."', '".$val."'
            )";
            $result=pwg_query($sql);
          }
          return(true);
        }        
      }
      return(false);
    }

    /*
      delete a translator from 'translators_users' & 'translators_users_langs' table
    */
    function delete_translator($nfo)
    {
      $sql="DELETE FROM ".$this->tables['users']."
            WHERE id = '".$nfo['id']."'";
      $result=pwg_query($sql);
      if($result)
      {
        $sql="DELETE FROM ".$this->tables['users_langs']." WHERE id = '".$nfo['id']."'";
        $result=pwg_query($sql);
        if($result)
        {
          $sql="UPDATE ".USER_INFOS_TABLE." SET adviser = 'false', status = 'normal' WHERE user_id = '".$nfo['id']."'";
          $result=pwg_query($sql);
          return(true);
        }
      }
      return(false);
    }


    /*
      from a string list FR,EN,ES,IT make a sorted array ENGLISH(EN), FRENCH(FR), ITALIAN(IT), SPANISH(ES)
    */
    function make_spoken_languages($languages)
    {
      $returned=Array();
      $tmp=explode(",", $languages);
      foreach($tmp as $key=>$val)
      {
        $tmp[$key]="'".$val."'";
      }

      $sql="SELECT code, name FROM ".$this->tables['langs_codes']." 
        WHERE code IN (".implode(",", $tmp).") 
        ORDER BY name";

      $result=pwg_query($sql);
      if($result)
      {
        while($row=mysql_fetch_assoc($result))
        { 
          $returned[]=ucfirst(strtolower($row['name']))."(".$row['code'].")";
        }
      }
      return($returned);
    }



    /*
      export an file into a .lang.php file
        $option is an array
          translator_export : 'y' or 'n' => if yes, add translator informations
          exported_items : 'ok' or 'valide_it' => if ok, only items with 'ok' status are exported
    */
    function export($fileid, $options=
      array(
        'exported_items' => 'ok',
        'translator_export' => 'n',
        'download_zip' => 'n',
        'export_sessid' => ''
      )
    )
    {
      global $user;

      if(!isset($options['download_zip'])) 
      {
        $options['download_zip']='n';
      }

      if(!isset($options['translator_export'])) 
      {
        $options['translator_export']='n';
      }

      if(!isset($options['exported_items'])) 
      {
        $options['exported_items']='ok';
      }

      /*
        if user is adviser or translator, don't allow him to do an export of 
        final files : only translator files is allowed, or download a zip file
      */
      if(is_adviser())
      {
        if($options['download_zip']=='n')
        {
          $options['translator_export']='y';
        }
      }

      $file_nfo=$this->get_file_info_by_id($fileid);

      $returned=array('errors' => array(), 'nfo'=>$file_nfo);

      $sql="SELECT t0.* FROM ".$this->tables['keys']." t0
            WHERE t0.file_id = '".$fileid."' 
              AND t0.version in
            (
              SELECT max(tmp.version) FROM ".$this->tables['keys']." tmp
              WHERE tmp.id = t0.id
                AND tmp.file_id = t0.file_id
              GROUP BY tmp.id
            )  ";


      if($options['translator_export']=='n')
      {
        $sql.=" AND (t0.status = 'ok'" ;
        if($options['exported_items']=='valide_it')
        {
          $sql.=" OR t0.status = 'valide_it' ";
        }

        $sql.=')';
      }
      $sql.=' ORDER BY t0.id';
      $result=pwg_query($sql);
      if($result)
      {
        $language_info=$this->get_language_info_by_code($file_nfo['language']);


        $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
        $local_tpl->set_filename('body_page',
                      dirname($this->filelocation).'/admin/plugin_admin_lang_php_utf-8.tpl');

        $exported=array(
          'lang_row' => array(),
          'lang_row_translator' => array()
        );

        $nbexported=0;
        while($row=mysql_fetch_array($result))
        {
          switch($row['status'])
          {
            case 'ok':
              $classstatus="tonfo";
              $status=l10n('g001_validated');
              break;
            case 'valide_it':
              $classstatus="tvnfo";
              $status=l10n('g001_to_validate');
              break;
            case 'not_translated':
              $classstatus="ttnfo";
              $status=l10n('g001_to_translate');
              break;
            case 'deleted':
              $classstatus="tdnfo";
              $status=l10n('g001_deleted');
              break;
          }
          $nbexported++;

          if(preg_match("/\s\[\#\d+]/", $row['id'], $tmp)>0)
          {
            //key is an item array
            preg_match("/\d+/", $tmp[0], $tmp);
            $keytab = "[".$tmp[0]."]";
            $tmp = preg_split("/\s\[\#\d+]/", $row['id']);
            $key = $tmp[0];
          }
          else
          {
            $key = $row['id'];
            $keytab = "";
          }

          if($options['translator_export']=='n')
          {
            $row_name='lang_row';
          }
          elseif(($options['translator_export']=='y')&&(strpos($key, '@bt@')!==false))
          {
            $row_name='lang_row';
            $row['translation'].="(".$key.")";
          }
          else
          {
            $row_name='lang_row_translator';
          }


          $exported[$row_name][]=array(
            'KEY' => $key,
            'KEYTAB' => $keytab,
            'VALUE' => addslashes($row['translation']),
            'STATUSCLASS' => $classstatus,
            'IDNUM' => $fileid*100000+$nbexported,
            'NAMENUM' => $row['uniqueindex'],
            'STATUS' => $status,
            'VERSION' => $row['version'],
            'DATE' => $row['date'],
            'TYPE' => $file_nfo['type'],
            'NAME' => $file_nfo['name'],
            'LANG_CODE' => $language_info['code'],
            'LANG_NAME' => $language_info['name'],
            'FILENAME' => $file_nfo['file']
          );
        }

        $template_exported=array(
          'DATE' => date('Y-m-d H:i:s'),
          'LANG_CODE' => $language_info['code'],
          'LANG_NAME' => $language_info['name'],
          'TYPE' => $file_nfo['type'],
          'NAME' => $file_nfo['name'],
          'TRANSLATOR' => $this->plugin_name,
          'VERSION' => TRANSLATOR_VERSION,
          'NBELEM' => $file_nfo['nb_elem'],
          'NBEXPORTED' => $nbexported,
          'EXPORTEDBY' => $user['username'],
          'EXPORT_TYPE' => $options['exported_items'],
          'TRANSLATOR_EXPORT' => ($options['translator_export']=='y')?'YES':'NO',
          'lang_row_translator' => $exported['lang_row_translator'],
          'lang_row' => $exported['lang_row']
        );

        if($file_nfo['file']=='common.lang.php')
        {
          $template_exported['lang_info_row']=array(
            'LANGUAGE_NAME' => $language_info['name'],
            'COUNTRY' => $language_info['country'],
            'LTR' => $language_info['direction'],
            'CODE' => $language_info['code'],
            'ZERO_PLURAL' => ($language_info['zero_plural']=='y')?'true':'false'
          );
        }

        $filename=$file_nfo['filename'];
        if($options['download_zip']=='y')
        {
          $filename=TRANSLATOR_PATH."zip/".$options['export_sessid']."/".substr($filename, 2);
        }

        $copyok=false;
        if($options['translator_export']=='n')
        {
          if(file_exists($filename))
          {
            if(@copy($filename, $filename.'.backup'))
            {
              $copyok=true;
              
            }
            else
            {
              array_push($returned['errors'], l10n('g001_error_export_2'));
            }
          }
          else
          {
            $copyok=true;
          }
        }
        else
        {
          $filename.=".t";
        }

        $returned['nfo']['exported_file']=$filename;
        $returned['nfo']['nbexported']=$nbexported;

        $local_tpl->assign('datas', $template_exported);

        if((($options['translator_export']=='n')&&($copyok))||(($options['translator_export']=='y')))
        {
          $this->mkpath(dirname($filename));
          @chmod(dirname($filename), 0777);
          $fhandle=@fopen($filename, 'w');
          if($fhandle)
          {
            fwrite($fhandle, $local_tpl->parse('body_page', true));
            fclose($fhandle);
            chmod($filename, 0777);
            if($options['translator_export']=='n')
            {
              $this->update_date_file($file_nfo);
            }
          }
          else
          {
            array_push($returned['errors'], l10n('g001_error_export_3'));
          }
        }
      }
      else
      {
        array_push($returned['errors'], l10n('g001_error_export_1'));
      }

      return($returned);
    }

    function mkpath($path)
    {
      if(@mkdir($path, 0777) or file_exists($path))
      {
        return(true);
      }
      else
      { 
        return($this->mkpath(dirname($path)) and mkdir($path, 0777));
      }
    }

    function delete_dir($path)
    {
      if (is_dir($path))
      {
        $fh = opendir($path);
        while ($file = readdir($fh))
        {
          if ($file != '.' and $file != '..')
          {
            $pathfile = $path . '/' . $file;
            if (is_dir($pathfile))
            {
              $this->delete_dir($pathfile);
            }
            else
            {
              @unlink($pathfile);
            }
          }
        }
        closedir($fh);
        return @rmdir($path);
      }
    }

    /*
      make zip file of a directory
    */
    function make_zip($zipname, $dirtozip)
    {
      $zip = new PclZip($zipname);
      $files=$this->search_languages_files($dirtozip);
      return($zip->create($files, PCLZIP_OPT_REMOVE_PATH, $dirtozip));
    }


    /*
      compare a key between server file and database
        function called by compare_file_and_database_keys function
    */
    function check_item_file_is_in_database($key, $val, &$database_keys, &$return)
    {
      if(is_array($val))
      {
        //$val is an array, check if all items of this array exists in database
        while(list($ikey, $ival) = each($val))
        {
          $this->check_item_file_is_in_database($key." [#".$ikey."]", $ival, $database_keys, $return);
        }
      }
      else
      {
        if(!isset($database_keys[$key]))
        {
          //keys doesn't exist in database
          $return['keynfo'][$key]=array('4', $val);
        }
      }
    }

    /*
      compare keys between server file and database
        return an array of each keys as array key, and value as :
        4 : exist on file, but not in database
        5 : exist in database, but not in file
        key existing in both are not returned
    */
    function compare_file_and_database_keys($ftype, $fname, $ffile, $flang)
    {
      unset($lang);
      $return=array();

      $nfo=$this->get_file_info($ftype, $fname, $ffile, $flang);
      $database_keys=$this->get_language_file_key_list($nfo[$flang]['id']);
      $return['filenfo']=$nfo[$flang];
      $return['keynfo']=array();

      //include .lang.php file to fill array 'lang'
      @include($nfo[$flang]['filename']);

      //check if server file's keys are in database
      foreach($lang as $key => $val)
      {
        $this->check_item_file_is_in_database($key, $val, $database_keys, $return);
      }

      //check if database's keys exists in server file
      foreach($database_keys as $key => $val)
      {
        if(preg_match("/\s\[\#\d+]/", $key, $tmp)>0)
        {
          //key is an item array
          //this function can't correctly manage arrays with more than one dimension
          preg_match("/\d+/", $tmp[0], $tmp);
          $keytab = $tmp[0];
          $tmp = preg_split("/\s\[\#\d+]/", $key);
          $testkey = $tmp[0];
          $isset=isset($lang[$testkey][$keytab]);
        }
        else
        {
          $isset=isset($lang[$key]);
          /*if($isset)
          {
            $isset=($lang[$key]!='');
          }*/
        }
        if(!$isset)
        {
          //keys doesn't exist in server file
          if($val!='deleted')
          {
            //if key status is not deleted, add the key 
            $return['keynfo'][$key]=array('5', '');
          }
        }
      }
      return($return);
    }

    function erase_file_from_database($file_id)
    {
      $sql="DELETE FROM ".$this->tables['files']." WHERE id='".$file_id."'";
      if(pwg_query($sql))
      {
        $sql="DELETE FROM ".$this->tables['keys']." WHERE file_id='".$file_id."'";
        if(pwg_query($sql))
        {
          return(true);
        }
      }
      return(false);
    }



    function search_phpt_backup_files($phpt=true, $backup=true, $dir="")
    {
      $returned=array();
      if($dir=="")
      {
        $dir = PHPWG_ROOT_PATH;
      }
      if(substr($dir,-1,1)=="/")
      {
        $dir=substr($dir,0,strlen($dir)-1);
      }
      if ($opendir = opendir($dir))
      {
        while ($file = readdir($opendir))
        {
          if ($file != '.'
              and $file != '..'
              and is_dir($dir.'/'.$file)
              and $file != 'CVS'
              and $file != '.svn')
          {
            $returned=array_merge($returned, $this->search_phpt_backup_files($phpt, $backup, $dir."/".$file));
          }
          else
          {
            if(
                  ((strpos(strtolower($file), ".lang.php.t")!==false)&&$phpt) ||
                  ((strpos(strtolower($file), ".lang.php.backup")!==false)&&$backup) 
            )
            {            
              array_push($returned, $dir.'/'.$file);
            }
          }
        }
      }    
      return($returned);
    }




    // from http://www.php.net/manual/en/function.in-array.php
    function recursive_in_array($needle, $haystack) {
        foreach ($haystack as $stalk) {
            if ($needle === $stalk || (is_array($stalk) && $this->recursive_in_array($needle, $stalk))) {
                return true;
            }
        }
        return false;
    }


    /* ---------------------------------------------------------------------------
      ajax functions
    --------------------------------------------------------------------------- */

    /*
      get detail information for status list
    */
    function ajax_translation_detail_list()
    {
      //global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_detail.tpl');

      $langs=$this->get_translated_languages();

      if($this->is_translator())
      {
        $translator_nfo=$this->get_translator_info();
        if($translator_nfo['display_spoken_lang']=='y')
        {
          $tmp_langs=strtolower($translator_nfo['spoken_language'].",".$translator_nfo['native_language']);
          $i=0;
          while($i<count($langs))
          {
            if(strpos($tmp_langs, substr($langs[$i],0,2))===false)
            {
              array_splice($langs, $i, 1);
            }
            else
            {
              $i++;
            }
          }
        }
      }

      $nfo=$this->get_file_info($_REQUEST['ftype'], $_REQUEST['fname'], $_REQUEST['ffile']);


      $nbtranslatedlang=0;
      $text="";
      $text2="";
      foreach($langs as $lang)
      {        
        if(isset($nfo[$lang]))
        {
          $nbtranslatedlang++;
          $local_tpl->set_filename('list_detail',
              dirname($this->filelocation).'/admin/plugin_admin_detail_1.tpl');

          $local_tpl->assign("datas",
            array(
              'NBELEM' => $nfo[$lang]['nb_elem'],
              'NBELEMTT' => $nfo[$lang]['nb_to_translate'],
              'NBELEMTV' => $nfo[$lang]['nb_to_validate'],
              'NBELEMTO' => $nfo[$lang]['nb_ok'],
              'NBELEMTD' => $nfo[$lang]['nb_deleted'],
              'PCTTT' => round(100*$nfo[$lang]['nb_to_translate']/$nfo[$lang]['nb_elem'],2),
              'PCTTV' => round(100*$nfo[$lang]['nb_to_validate']/$nfo[$lang]['nb_elem'],2),
              'PCTTO' => round(100*$nfo[$lang]['nb_ok']/$nfo[$lang]['nb_elem'],2),
              'PCTTD' => round(100*$nfo[$lang]['nb_deleted']/$nfo[$lang]['nb_elem'],2)
            )
          );

          $text_tmp='<a href="'.$this->page_link.'&f_tabsheet=editing&action=edit&fileid='.$nfo[$lang]['id'].'">'.l10n('g001_edit').'</a>';

          if(!$this->is_translator())
          {
            $text_tmp.='<br/><a style="cursor:pointer;position:absolute;" id="imenu1'.$nfo[$lang]['id'].'" onclick="display_menu1(\''.$nfo[$lang]['id'].'\')">'.l10n('g001_translate_to').'</a>';
          }

          /* <a href="'.$this->page_link.'&f_tabsheet=tools&action=translateto&fileid='.$nfo[$lang]['id'].'">'.l10n('g001_translate_to').'</a>'; */


        }
        else
        {
          $local_tpl->set_filename('list_detail',
              dirname($this->filelocation).'/admin/plugin_admin_detail_2.tpl');
          $local_tpl->assign("datas", 
            array(
              'CELLTEXT' => l10n('g001_no_translation_exists')
            )
          );
    
          $text_tmp='<br/>&nbsp;';
        }
        $text.=$local_tpl->parse('list_detail', true);
                    
        $local_tpl->set_filename('list_detail2',
          dirname($this->filelocation).'/admin/plugin_admin_detail_2.tpl');
          $local_tpl->assign("datas",
            array(
              'CELLTEXT' => $text_tmp
            )
          );
        $text2.=$local_tpl->parse('list_detail2', true);

      }

      $template_datas=array(
        'TEXT' => $text,
        'TEXT2' => $text2,
        'can_compare' => array()
      );
      if($nbtranslatedlang>1)
      {
        $template_datas['can_compare'] =array(
          'COMPARE_LANGUAGE_LINK' => $this->page_link.'&f_tabsheet=editing&action=compare_lang&ftype='.$_REQUEST['ftype'].
                                    '&fname='.urlencode($_REQUEST['fname']).
                                    '&ffile='.urlencode($_REQUEST['ffile'])
        );
      }
      else
      {
        $template_datas['can_compare'] = "false";
      }

      $local_tpl->assign("datas", $template_datas);
      
      return($local_tpl->parse('body_page', true));
    }


    /*
      get file detail nfo 
    */
    function ajax_file_nfo()
    {
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_edit_detail1.tpl');

      $nfo=$this->get_file_info_by_id($_REQUEST['fileid']);

      $local_tpl->set_filename('list_detail',
          dirname($this->filelocation).'/admin/plugin_admin_detail_1.tpl');

      $template_datas=array(
        'NBELEM' => $nfo['nb_elem'],
        'NBELEMTT' => $nfo['nb_to_translate'],
        'NBELEMTV' => $nfo['nb_to_validate'],
        'NBELEMTO' => $nfo['nb_ok'],
        'NBELEMTD' => $nfo['nb_deleted'],
        'PCTTT' => round(100*$nfo['nb_to_translate']/$nfo['nb_elem'],2),
        'PCTTV' => round(100*$nfo['nb_to_validate']/$nfo['nb_elem'],2),
        'PCTTO' => round(100*$nfo['nb_ok']/$nfo['nb_elem'],2),
        'PCTTD' => round(100*$nfo['nb_deleted']/$nfo['nb_elem'],2)
      );
      $local_tpl->assign("datas", $template_datas);
      $nfo_work_progress=$local_tpl->parse('list_detail', true);

      $nfo_width_tt = ceil(2.5*$this->my_config['bars_width']*$nfo['nb_to_translate']/$nfo['nb_elem']);
      $nfo_width_tv = ceil(2.5*$this->my_config['bars_width']*$nfo['nb_to_validate']/$nfo['nb_elem']);
      $nfo_width_to = ceil(2.5*$this->my_config['bars_width']*$nfo['nb_ok']/$nfo['nb_elem']);
      $nfo_width_td = ceil(2.5*$this->my_config['bars_width']*$nfo['nb_deleted']/$nfo['nb_elem']);


      $template_datas=array(
        'NFO_WIDTH_TT' => $nfo_width_tt,
        'NFO_WIDTH_TV' => $nfo_width_tv,
        'NFO_WIDTH_TO' => $nfo_width_to,
        'NFO_WIDTH_TD' => $nfo_width_td,
        'NFO_WORK_PROGRESS' => $nfo_work_progress,
        'NFO_LNK_ACTION_VALIDATE_ALL' => ($nfo['nb_to_validate']>0)?'['.l10n('g001_validate_all').']':''
      );

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      load list of items
    */
    function ajax_load_edit_list()
    {
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_edit_detail2.tpl');

      $file_id=$_REQUEST['fileid'];
      $translator='0';
      $status='';
      $page=1;
      if(isset($_REQUEST['ftranslator']))
      {
        $translator=$_REQUEST['ftranslator'];
      }
      if(isset($_REQUEST['fstatus']))
      {
        $status=$_REQUEST['fstatus'];
      }
      if(isset($_REQUEST['fpage']))
      {
        $page=$_REQUEST['fpage'];
      }
      if($status=='none')
      {
        $status='';
      }

      $template_datas=array(
        'keys' => array()
      );

      $fileitems=$this->get_language_file_items($file_id, $status, $translator, $page);
      //$nfo=$this->get_file_info_by_id($file_id);

      foreach($fileitems['list'] as $item)
      {
        switch($item['status'])
        {
          case 'ok':
            $status="g001_graphbar3";
            break;
          case 'valide_it':
            $status="g001_graphbar2";
            break;
          case 'not_translated':
            $status="g001_graphbar1";
            break;
          case 'deleted':
            $status="g001_graphbar4";
            break;
        }

        $template_datas['keys'][]=array(
          'KEY64' => base64_encode($item['id'])  ,
          'KEY' => $item['id'],
          'STATUS' => $status,
          'VALUE' => $item['translation']
        );
      }

      $pagesnav=new pages_navigation();
      $pagesnav->set_nb_items($fileitems['pages']);
      $pagesnav->set_nb_items_per_page($this->my_config['number_of_items']);
      $pagesnav->set_current_page($page);
      $template_datas['PAGES_NAVIGATION']=$pagesnav->make_navigation('load_list');

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      return keys nfo in an html formatted string
    */
    function ajax_key_nfo()
    {
      //global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_edit_detail3.tpl');

      $idkey=base64_decode($_REQUEST['fkey']);
      $nfokey=$this->get_key_nfo($_REQUEST['fileid'], addslashes($idkey));
      $nfofile=$this->get_file_info_by_id($_REQUEST['fileid']);

      $template_datas=array(
        'TEXT' => $nfokey[0]['translation'],
        'ID64' => base64_encode($idkey),
        'VERSION' => $nfokey[0]['version'],
        'langs' => array(),
        'versions_rows' => array(),
        'valide_it' => false,
        'delete_it' => false
      );

      if(($nfokey[0]['status']=='valide_it')||($nfokey[0]['status']=='deleted'))
      {
        $template_datas['valide_it']=true;
      }
      if($nfokey[0]['status']!='deleted')
      {
        $template_datas['delete_it']=true;
      }
  
      if($this->is_translator())
      {
        $translator_nfo=$this->get_translator_info();
        if($this->recursive_in_array($translator_nfo['default_displayed_language'], $nfofile['langs']))
        {
          $selected_lang=$translator_nfo['default_displayed_language'];
        }
        else
        {
          $selected_lang=$this->my_config['mainlang'];
        }
      }
      else
      {
        $selected_lang=$this->my_config['mainlang'];
      }

      foreach($nfofile['langs'] as $nfo)
      {
        $template_datas['langs'][]=array(
          'LANG' => $nfo['id'],
          'SELECT' => ($nfo['language']==$selected_lang)?' selected':'',
          'TEXT' => $nfo['language']
        );
      }

      foreach($nfokey as $key =>$nfo)
      {
        $template_datas['versions_rows'][]=array(
          'ID64' => base64_encode($idkey),
          'VERSION' => $nfo['version'],
          'CREATE_DATE' => $nfo['date'],
          'CREATE_BY' => $nfo['create_by_name'],
          'VALIDATE_DATE' => ($nfo['validate_date']=='0000-00-00 00:00:00')?'':$nfo['validate_date'],
          'VALIDATE_BY' => $nfo['validate_by_name'],
          'VALUE' => $nfo['translation']
        );
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      just return value of a key
    */
    function ajax_key_value()
    {
      $nfo=$this->get_key_nfo($_REQUEST['fileid'], base64_decode($_REQUEST['fkey']));

      $returned=$nfo[0]['translation'];

      if(isset($_REQUEST['translatelnk'])&&($_REQUEST['translatelnk']=='y')&&
         (isset($_REQUEST['ffrom']))&& (isset($_REQUEST['fto']) ))
      {
        $class=array(
          'ok' => 'g001_graphbar3',
          'valide_it' => 'g001_graphbar2',
          'not_translated' => 'g001_graphbar1',
          'deleted' => 'g001_graphbar4'
        );
        $returned='<div class="'.$class[$nfo[0]['status']].'" style="width:10px;">&nbsp;</div><div id="imodeltrans_'.$_REQUEST['fkey'].'">'.$returned."</div>";
        if($this->google_translate->can_translate($_REQUEST['ffrom'], $_REQUEST['fto']))
        {
          $returned.='<a style="cursor:pointer;" onclick="do_translation(\''.base64_encode($nfo[0]['id']).'\')">'.l10n('g001_google_translate').'</a>';
        }
      }

      return($returned);
    }

    /*
      validate a translation
    */
    function ajax_validate_translation()
    {
      global $user;

      $result=$this->change_key_status($_REQUEST['fileid'], addslashes(base64_decode($_REQUEST['fkey'])), $_REQUEST['fversion'], $user['id'], 'ok');
      if($result)
      {
        return('ok');
      }
      else
      {
        return('ko');
      }
    }

    /*
      validate all translation wich status equal 'valide_it'
    */
    function ajax_validate_all()
    {
      global $user;

      $result=$this->change_key_status($_REQUEST['fileid'], '', '', $user['id'], 'ok');
      if($result)
      {
        return('ok');
      }
      else
      {
        return('ko');
      }
    }


    /*
      delete a key. key is deleted in all languages.
    */
    function ajax_delete_key()
    {
      global $user;

      $result=$this->delete_key($_REQUEST['fileid'], addslashes(base64_decode($_REQUEST['fkey'])), $user['id']);
      if($result)
      {
        return('ok');
      }
      else
      {
        return('ko');
      }
    }


    /*
      apply a translation
    */
    function ajax_apply_translation()
    {
      global $user;
      $result=$this->insert_key_translation($_REQUEST['fileid'], addslashes(base64_decode($_REQUEST['fkey'])), $user['id'], stripslashes($_POST['fvalue']));
      if($result)
      {
        return('ok');
      }
      else
      {
        return('ko');
      }
    }

    /*
      make a formatted list.<option></option> of existing languages not translated
    */
    function ajax_langs_list()
    {
      $langs=array_flip($this->get_translated_languages());
      $filelangs=$this->get_file_info_by_id($_REQUEST['fileid']);

      $returned="";
      foreach($filelangs['langs'] as $lang)
      {
        if(isset($langs[$lang['language']]))
        {
          unset($langs[$lang['language']]);
        }
      }
      foreach($langs as $key => $lang)
      {
        $returned.="<option value='".$key."'>".$key."</option>";
      } 

      if($returned=='')
      {
        $returned="<div class='throw' style='padding:2px;font-size:90%;'>".
            sprintf(l10n('g001_add_new_language_ko'),
            "<br/><a href='".$this->page_link."&f_tabsheet=langs&action=add'>", "</a>")."</div>";
      }
      else
      {
        $returned="<select name='flang' onchange='f=document.forms[\"icreatenlang\"];f.submit();'><option>".l10n('g001_choose_lang')."</option>".$returned."</select>
                    <input type='hidden' name='fileid' value='".$_REQUEST['fileid']."'>
                    <input type='hidden' value='translateto' name='action'>
                    <input type='hidden' value='editing' name='f_tabsheet'>";
      }
      return($returned);
    }

    /*
      return a formatted list of languages 
    */
    function ajax_get_languages_list()
    {
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_langs_detail1.tpl');

      $langs=$this->get_langs_list();
      $template_datas=array('langs_row'=>array());
      foreach($langs as $lang)
      {
        $template_datas['langs_row'][]=array(
          "LANG" => $lang['name'],
          "COUNTRYFLAG" =>  TRANSLATOR_PATH."img/".strtolower($lang['country_code']).".png",
          "COUNTRY" => $lang['country'],
          "CODE" => $lang['code'],
          "NBFILE" => $lang['nbfile'],
          "URL" => $this->page_link."&f_tabsheet=langs&action=edit&code=".urlencode($lang['code'])
        );
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      export phase 0 :
        create js&html code to prepare export interface
    */
    function ajax_export_phase0()
    {
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_maintenance_export_phase0.tpl');

      $template_datas=array(
        'OPTION_LIST' => '&f_exported_items='.$_POST['f_exported_items'].'&f_translator_export='.$_POST['f_translator_export'].'&f_zip_export='.$_POST['f_zip_export']."&f_exp_sessid=".$_POST['f_exp_sessid'],
        'PROGRESS_BAR_MAX' => $this->my_config['progress_bar_width'],
        'PROGRESS_BAR_COLOR' => $this->my_config['mouse_over_color'],
        'id_list_row' => array()
      );

      $sql="SELECT id, nb_elem FROM ".$this->tables['files'];
      $idlist=array();
      if($_POST['f_file_selection_type']=='selected')
      {
        foreach($_POST as $key => $val)
        {
          if((substr($key, 0, 4)=='fid_')&&(is_numeric($val)))
          {
            array_push($idlist, $val);
          }
        }
        $sql.=" WHERE id IN (".implode(',', $idlist).") ";
      }
      $sql.=" ORDER BY nb_elem";

      $result=pwg_query($sql);
      if($result)
      {
        $num=0;
        $list=array('nb' => 0, 'ids' => array());
        while($row=mysql_fetch_assoc($result))
        {
          if($list['nb']+$row['nb_elem']<=$this->my_config['export_maximum_items'])
          {
            $list['nb']+=$row['nb_elem'];
            array_push($list['ids'], $row['id']);
          }
          else
          {
            $template_datas['id_list_row'][]=array(
              'NUM' => $num,
              'VALUES' => 'list='.urlencode(implode(',', $list['ids']))
            );
            $num++;
            $list['nb']=$row['nb_elem'];
            $list['ids']=array($row['id']);
          }
        }
        $template_datas['id_list_row'][]=array(
          'NUM' => $num,
          'VALUES' => 'list='.urlencode(implode(',', $list['ids']))
        );
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      export phase 1
      make .lang.php files
    */
    function ajax_export_phase1()
    {
      if(isset($_POST['list']))
      {
        $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
        $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_maintenance_export_nfo.tpl');

        $template_datas=array('result_row'=>array());
        $list=explode(',', $_POST['list']);
        foreach($list as $fileid)
        {
          $options=array(
            'exported_items' => $_POST['f_exported_items'],
            'translator_export' => $_POST['f_translator_export'],
            'download_zip' => $_POST['f_zip_export'],
            'export_sessid' => $_POST['f_exp_sessid']
          );
          $result=$this->export($fileid, $options);
          
          if(count($result['errors'])==0)
          {
            $template_datas['result_row'][]=array(
              'NBEXPORTED' => $result['nfo']['nbexported'],
              'NBELEM' => $result['nfo']['nb_elem'],
              'TYPE' => $result['nfo']['type'],
              'NAME' => $result['nfo']['name'],
              'FILE' => $result['nfo']['file'],
              'FILENAME' => $result['nfo']['exported_file'].' #id:'.$result['nfo']['id'],
              'RESULT_COLOR' => $this->my_config['color_bars3'],
              'EXPORT_RESULT' => l10n('g001_export_ok')
            );
          }
          else
          {
            $template_datas['result_row'][]=array(
              'NBEXPORTED' => 0,
              'NBELEM' => $result['nfo']['nb_elem'],
              'TYPE' => $result['nfo']['type'],
              'NAME' => $result['nfo']['name'],
              'FILE' => $result['nfo']['file'],
              'FILENAME' => $result['nfo']['exported_file'],
              'RESULT_COLOR' => $this->my_config['color_bars1'],
              'EXPORT_RESULT' => l10n('g001_export_ko').' : '.implode(', ', $result['errors'])
            );
          }
        }

        $local_tpl->assign("datas", $template_datas);
        return($local_tpl->parse('body_page', true));
      }
    }


    /*
      export zip
      make a zip with all exported .lang.php files
    */
    function ajax_export_zip()
    {
      $zipname=TRANSLATOR_PATH."zip/translator.langs-zip.".$_REQUEST['f_exp_sessid'];
      $this->make_zip($zipname, TRANSLATOR_PATH."zip/".$_REQUEST['f_exp_sessid']."/");
      
      $fhandler=fopen($zipname, "r");
      if($fhandler)
      {
        $data=fread($fhandler, filesize($zipname));
        fclose($fhandler);
        unlink($zipname);
        $this->delete_dir(TRANSLATOR_PATH."zip/".$_REQUEST['f_exp_sessid']."/");

        header("Content-type: application/x-zip");
        header('Content-Disposition: inline; filename=langs.zip') ;

        return($data);
      }
    }



    /*
      return info about a key
    */
    function ajax_get_key_nfo()
    {
      $nfo=$this->get_key_nfo_by_unique_index($_REQUEST['uindex']);

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_keynfo.tpl');

      switch($nfo['status'])
      {
        case 'ok':
          $color="color_bars3";
          break;
        case 'valide_it':
          $color="color_bars2";
          break;
        case 'not_translated':
          $color="color_bars1";
          break;
        case 'deleted':
          $color="color_bars4";
          break;
      }


      $template_datas=array(
        'KEY' => $nfo['id'],
        'STATUS' => $nfo['status'],
        'COLOR' => $this->my_config[$color],
        'VERSION' => $nfo['version'],
        'DATE' => ($nfo['status']=='ok')?$nfo['validate_date']:$nfo['date'],
        'TYPE' => $nfo['type'],
        'NAME' => $nfo['name'],
        'FILENAME' => $nfo['file'],
        'FILEDATE' => $nfo['file_date'],
        'LANGUAGE' => $nfo['language'],
        'user_info' => false
      );

      if($nfo['status']=='ok')
      {
        $template_datas['user_info']=array(
          'USERNAME' => $nfo['validate_by_name'],
          'DATE' => $nfo['validate_date']
        );
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }

    /*
      returns a list of keys who are present in some language file and not in other 
    */
    function ajax_translation_compare_list()
    {
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");

      $sql="SELECT id, language FROM ".$this->tables['files']."
            WHERE name = '".$_REQUEST['fname']."'
              AND type = '".$_REQUEST['ftype']."'
              AND file = '".$_REQUEST['ffile']."'
            ORDER BY language";
      $result=pwg_query($sql);
      if($result)
      {
        $list = array();
        while($row=mysql_fetch_row($result))
        {
          array_push($list, $row);
        }

        $sql_list=array();
        for($i=0;$i<count($list);$i++)
        {
          $sql_listtmp=array();
          for($j=0;$j<count($list);$j++)
          {
            if($list[$i][0]!=$list[$j][0])
            {
              $sql_listtmp[$j] = "id NOT IN (SELECT DISTINCT id
                                                  FROM ".$this->tables['keys']."
                                                  WHERE file_id = ".$list[$j][0]."
                                                ) ";
            }
          }

          $sql_list[$i] = "SELECT DISTINCT id, ".$this->make_compare_columns($i, count($list))."
                            FROM ".$this->tables['keys']."
                            WHERE file_id = ".$list[$i][0]."
                              AND (" .implode(" OR ", $sql_listtmp).") ";

        }
        $sql=implode(" UNION ", $sql_list)." ORDER BY id";

        $result=pwg_query($sql);
        if($result)
        {
          if(mysql_num_rows($result)>0)
          {
            //making an array with unique index and status for all language
            $idlist=array();
            while($row=mysql_fetch_row($result))
            {
              for($i=0;$i<count($list);$i++)
              {
                if(isset($idlist[$row[0]][$i]))
                {
                  if($idlist[$row[0]][$i]=="")
                  {
                    $idlist[$row[0]][$i]=$row[$i+1];
                  }
                }
                else
                {
                  $idlist[$row[0]][$i]=$row[$i+1];
                }
              }
            }

            $template_datas=array(
              'lang_header_cols' => array(),
              'nbelem_header_cols' => array(),
              'keys' => array(),
            );
            $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_compare_list.tpl');

            //table header
            for($i=0;$i<count($list);$i++)
            {
              $template_datas['lang_header_cols'][]=array(
                'WIDTH' => $this->my_config['bars_width'],
                'FLAG' => TRANSLATOR_PATH."img/".strtolower(substr($list[$i][1],3,2).".png"),
                'LABEL' => $list[$i][1]
              );

              $nfo=$this->get_file_info_by_id($list[$i][0]);
              $template_datas['nbelem_header_cols'][]=array(
                'LABEL' => $nfo['nb_elem']
              );
            }

            //keys ; paging not implemted, assuming that number of keys to be updated may not be large
            foreach($idlist as $key => $val)
            {
              $datactrl = "";
              $tds = array();
              for($i=0;$i<count($val);$i++)
              {
                if($val[$i]!="")
                {
                  switch($val[$i])
                  {
                    case 'ok':
                      $color="g001_graphbar3";
                      break;
                    case 'valide_it':
                      $color="g001_graphbar2";
                      break;
                    case 'not_translated':
                      $color="g001_graphbar1";
                      break;
                    case 'deleted':
                      $color="g001_graphbar4";
                      break;
                  }
                  array_push($tds, "<div class='".$color."' style='width:".$this->my_config['bars_width']."px'>&nbsp;</div>");
                }
                else
                {
                  array_push($tds, l10n('g001_keys_dont_exists'));
                  $datactrl.= ($datactrl=="")?$list[$i][0]:",".$list[$i][0];
                }
              }

              $tmp_nfo_lang_status=array();
              for($i=0;$i<count($tds);$i++)
              {
                $tmp_nfo_lang_status[]=array(
                  'TEXT' => $tds[$i]
                );
              }

              $template_datas['keys'][]=array(
                'NAME' => $key,
                'ID' => str2url($key),
                'DATA' => $datactrl,
                'nfo_lang_status' => $tmp_nfo_lang_status
              );

            }

            $template_datas['NOTTRANSLATOR']=!$this->is_translator();
            $template_datas['NBCOLS']=count($list);
            $local_tpl->assign("datas", $template_datas);
          }
          else
          {
            //no differences
            $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_compare_nolist.tpl');
          }
        }
        else
        {
          //sql error !?
        }
      }
      else
      {
        //sql error !?
      }
      return($local_tpl->parse('body_page', true));
    } //ajax_translation_compare_list


    /*
      update keys ; add selected keys to languages
    */
    function ajax_translation_compare_update()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_compare_update.tpl');
      $template_datas=array(
        'errors' => array(),
        'TEXT' => '',
        'TEXTCLASS' => ''
      );

      if($this->is_translator())
      {
        $template_datas['TEXTCLASS']='errors';
        $template_datas['TEXT']=l10n("g001_translator_not_allowed");
      }
      elseif(is_adviser())
      {
        $template_datas['TEXTCLASS']='errors';
        $template_datas['TEXT']=l10n("g001_translator_adviser_not_allowed");
      }
      else
      {
        $errors=0;
        $text="";
        foreach($_POST as $key => $val)
        {
          $data=explode("#gsep#", $val);
          $text.="key:".$data[1]."files:".$data[0]."<br/>";

          $files=explode(",", $data[0]);
          foreach($files as $key2 => $val2)
          {
            if($_REQUEST['fmode']=='add')
            {
              $result=$this->insert_key_translation($val2,$data[1],$user['id'],$data[1], 'not_translated');
            }
            else
            {
              $result=$this->delete_key($val2, $data[1], $user['id']);
            }
            if(!$result)
            {
              $nfo=$this->get_file_info_by_id($val2);
              $errors++;
              $template_datas['errors'][]=array(
                'NFO' => l10n('g001_key')." : ".$data[1].", &nbsp;".l10n('g001_file')." : ".$nfo['language']
              );
            }
          }
        }
        if($errors==0)
        {
          $template_datas['TEXT']=l10n('g001_compare_update_isok');
          $template_datas['TEXTCLASS']='infos';
        }
        else
        {
          $template_datas['TEXT']=l10n('g001_compare_update_isko');
          $template_datas['TEXTCLASS']='errors';
        }
      }
      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      erase "deleted keys" and older key's translation version
      erase .phpt files and backup files
    */
    function ajax_erase()
    {
      global $user;

      //$local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
/*
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_edit_compare_update.tpl');
*/
      $textok="";
      $textko="";
      if(!is_adviser())
      {

        $textok=l10n("g001_erase_done")."<br/>";

        if($_REQUEST['deleted']=='y')
        {
          $sql="UPDATE ".$this->tables['files']." 
                SET file_date = '0000-00-00 00:00:00' 
                WHERE id IN
                  (SELECT DISTINCT file_id
                      FROM ".$this->tables['keys']." 
                      WHERE status = 'deleted')";
          pwg_query($sql);

          $sql="DELETE FROM ".$this->tables['keys']."
                WHERE status = 'deleted';";
          $result=pwg_query($sql);
          if($result)
          {
            $nb=mysql_affected_rows();
            $textok.=sprintf(l10n('g001_erase_nb_deleted_deleted'), $nb)."<br/>";
          }
          else
          {
            $textko.=l10n('g001_error_erase_deleted')."<br/>";
          }
        }

        if($_REQUEST['older']=='y')
        {
          $sql="DROP TABLE IF EXISTS tmp_translator";
          pwg_query($sql);

          $sql="CREATE TABLE tmp_translator
                SELECT uniqueindex FROM ".$this->tables['keys'].",
                (SELECT id, count(version)as numversion, file_id
                    FROM ".$this->tables['keys']."
                    GROUP BY id, file_id) as tmp
                WHERE tmp.id = ".$this->tables['keys'].".id
                  AND tmp.file_id = ".$this->tables['keys'].".file_id
                  AND ".$this->tables['keys'].".version < tmp.numversion
                  AND tmp.numversion > 1";
          $result=pwg_query($sql);
          if($result)
          {
            $sql="DELETE FROM ".$this->tables['keys']."
                  WHERE uniqueindex IN (SELECT uniqueindex FROM tmp_translator)";
            $result=pwg_query($sql);
            if($result)
            {
              $nb=mysql_affected_rows();
              $textok.=sprintf(l10n('g001_erase_nb_deleted_older'), $nb)."<br/>";
            }
            else
            {
              $textko.=l10n('g001_error_erase_older')."<br/>";
            }
            $sql="DROP TABLE IF EXISTS tmp_translator";
            pwg_query($sql);
          }
        }

        if($_REQUEST['phptfiles']=='y' || $_REQUEST['backupfiles']=='y')
        {
          $nbsupp=0;
          $listeko="";
          $listfile=$this->search_phpt_backup_files(($_REQUEST['phptfiles']=='y'), ($_REQUEST['backupfiles']=='y'));
          foreach($listfile as $key=>$val)
          {
            if(!unlink($val))
            {
              $listeko.="$val<br/>";
            }
            else
            {
              $nbsupp++;
            }
          }
          if($listeko!="")
          {
            $textko.=l10n('g001_error_erase_file')."<br/>".$listeko;
          }
          $textok.=sprintf(l10n('g001_erase_nb_deleted_files'), $nbsupp)."<br/>";
        }        
      }
      else
      {
        $textko=l10n("g001_translator_adviser_not_allowed");
      }


      $text="";
      if($textok!="")
      {
        $text.="<div class='infos'>$textok</p>";
        $this->update_file_counter();
      }
      if($textko!="")
      {
        $text.="<div class='errors'>$textko</p>";
      }

      return($text);
    }

    /*
      this function switch translator mode in config file 
    */
    function ajax_switch_translator_mode()
    {
      global $user;

      $done='ko';
      $this->load_config();
      $search=array_search($user['id'], $this->my_config['translator_mode']);
      if($_REQUEST['f_translator_mode']=='on')
      {
        if($search===false)
        {
          //array_push($this->my_config['translator_mode'], $user['id']);
          //same result, but seems to be faster
          $this->my_config['translator_mode'][]=$user['id'];
          $this->save_config();
          $done='ok';
        }
      }
      else
      {
        if($search!==false)
        {
          array_splice($this->my_config['translator_mode'], $search, 1);
          $this->save_config();
          $done='ok';
        }
      }

      return("asked:".$_REQUEST['f_translator_mode']."; done:".$done." search result:".$search." user_id:".$user['id']." array:".print_r($this->my_config['translator_mode'],true));
    }


    /*
      analyze differences between server&database file
    */
    function ajax_analyze_detail()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_analyze_detail.tpl');

      $nbdiff=array(0,0,0);

      $template_datas=array(
        'TXTDIFF' => '',
        'VISIBILITY' => '',
        'files_row' => array(),
        'actions1a' => false,
        'actions1b' => false,
        'actions2' => false,
        'actions3' => false,
        'ISTRANSLATOR' => $this->is_translator()
      );

      if($_REQUEST['fnumfinding']=='1')
      {
        //file on server has changed

        $keydiff=$this->compare_file_and_database_keys($_REQUEST['ftype'],$_REQUEST['fname'],$_REQUEST['ffile'],$_REQUEST['flang']);

        foreach($keydiff['keynfo'] as $key => $val)
        {
          $template_datas['files_row'][]=array(
            'KEY' => $key,
            'FINDING' => l10n('g001_finding_num'.$val[0])
          );
          if($val[0]=='4')
          {
            $nbdiff[1]++;
          }
          else
          {
            $nbdiff[2]++;
          }
        }
        $nbdiff[0]=count($keydiff['keynfo']);

        $template_datas['TXTDIFF']=sprintf(l10n('g001_analyze_nbdiff'), $nbdiff[0]);

        if($nbdiff[1]>0)
        {
          $template_datas['actions1a']=array(
            'CBIDA' => md5($_REQUEST['ftype'].$_REQUEST['fname'].$_REQUEST['ffile'].$_REQUEST['flang'].'1A'),
            'TYPE' => $_REQUEST['ftype'],
            'NAME' => $_REQUEST['fname'],
            'FILE' => $_REQUEST['ffile'],
            'LANG' => $_REQUEST['flang']
          );
        }

        if($nbdiff[2]>0)
        {
          $template_datas['actions1b']=array(
            'CBIDB' => md5($_REQUEST['ftype'].$_REQUEST['fname'].$_REQUEST['ffile'].$_REQUEST['flang'].'1B'),
            'TYPE' => $_REQUEST['ftype'],
            'NAME' => $_REQUEST['fname'],
            'FILE' => $_REQUEST['ffile'],
            'LANG' => $_REQUEST['flang']
          );
        }
      }
      elseif($_REQUEST['fnumfinding']=='2')
      {
        //file on server doesn't exists in database
        $langs=array_flip($this->get_translated_languages(true));

        $txtdiff="";
        if(!isset($langs[strtolower($_REQUEST['flang'])]))
        {
          $url="<a href='".$this->page_link."&f_tabsheet=langs&action=add&langcode=".urlencode($_REQUEST['flang'])."'>".sprintf(l10n('g001_finding_num6b'), $_REQUEST['flang'])."</a>";
          $txtdiff=sprintf(l10n('g001_finding_num6'), $url);
        }

        if($txtdiff=="")
        {
          $template_datas['actions2']=array(
            'CBIDA' => md5($_REQUEST['ftype'].$_REQUEST['fname'].$_REQUEST['ffile'].$_REQUEST['flang'].'2A'),
            'TYPE' => $_REQUEST['ftype'],
            'NAME' => $_REQUEST['fname'],
            'FILE' => $_REQUEST['ffile'],
            'LANG' => $_REQUEST['flang']
          );
        }
        $template_datas['VISIBILITY']='visibility: hidden;height:0px;';
        $template_datas['TXTDIFF']=$txtdiff;
      }
      elseif($_REQUEST['fnumfinding']=='3')
      {
        //file in database doesn't exists on server
        $template_datas['actions3']=array(
          'CBIDA' => md5($_REQUEST['ftype'].$_REQUEST['fname'].$_REQUEST['ffile'].$_REQUEST['flang'].'3A'),
          'TYPE' => $_REQUEST['ftype'],
          'NAME' => $_REQUEST['fname'],
          'FILE' => $_REQUEST['ffile'],
          'LANG' => $_REQUEST['flang']
        );

        $template_datas['VISIBILITY']='visibility: hidden;height:0px;';
      }
      else
      {
        //??
      }
      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      return result of analyze
    */
    function ajax_analyze_list()
    {
      global $user;

      
      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_analyze_list.tpl');

      //make a scan of directories
      $disk_filesdatas=array();
      $files=$this->search_languages_files(PHPWG_ROOT_PATH."language");
      $files=array_merge($files, $this->search_languages_files(PHPWG_PLUGINS_PATH));
      foreach($files as $file)
      {
        $nfo=$this->analyze_filename($file);
        $disk_filesdatas[$nfo['filename']]=$nfo;
      }

      $base_datasfiles=$this->get_all_files();

      $template_datas=array(
        'diff_files' =>array(),
        'ISTRANSLATOR' => $this->is_translator()
      );

      $numfile=0;
      foreach($base_datasfiles as $file)
      {
        if(isset($disk_filesdatas[$file['filename']]))
        {
          if(date('Y-m-d H:i:s', $disk_filesdatas[$file['filename']]['modified'])!=$file['file_date'])
          {
            // date file on server has changed
            $keydiff=$this->compare_file_and_database_keys($file['type'],$file['name'],$file['file'],$file['language']);
            if(count($keydiff['keynfo'])>0)
            {
              $numfile++;
              $template_datas['diff_files'][]=array(
                'ID' => $numfile,
                'TYPE' => $file['type'],
                'NAME' => $file['name'],
                'FILE' => $file['file'],
                'LANG' => $file['language'],
                'NUMFINDING' => '1',
                'FINDING' => l10n('g001_finding_num1').' ('.$file['filename'].')'
              );
            }
          }
          unset($disk_filesdatas[$file['filename']]);
        }
        else
        {
          // file on server does not exist
          $numfile++;
          $template_datas['diff_files'][]=array(
            'ID' => $numfile,
            'TYPE' => $file['type'],
            'NAME' => $file['name'],
            'FILE' => $file['file'],
            'LANG' => $file['language'],
            'NUMFINDING' => '3',
            'FINDING' => l10n('g001_finding_num3').' ('.$file['filename'].')'
          );
        }
      }

      //files in array are file existing on serveur and doesn't exist on database
      foreach($disk_filesdatas as $file)
      {
        $numfile++;
        $template_datas['diff_files'][]=array(
          'ID' => $numfile,
          'TYPE' => $file['type'],
          'NAME' => $file['name'],
          'FILE' => $file['file'],
          'LANG' => $file['lang'],
          'NUMFINDING' => '2',
          'FINDING' => l10n('g001_finding_num2').' ('.$file['filename'].')'
        );
      }

      if($numfile>0)
      {
        $local_tpl->assign("datas", $template_datas);
        return($local_tpl->parse('body_page', true));
      }
      else
      {
        return("<p>".l10n('g001_analyze_nodiff')."</p>");
      }
    }


    /*
      return result of analyze
    */
    function ajax_analyze_upgrade()
    {
      global $user;

      if($this->is_translator())
      {
        return("<p class='errors'>".l10n('g001_translator_not_allowed')."</p>");
      }
      elseif(is_adviser())
      {
        return("<p class='errors'>".l10n('g001_translator_adviser_not_allowed')."</p>");
      }

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_analyze_upgrade.tpl');

      $template_datas=array('result_row'=>array());
      foreach($_POST as $key => $val)
      {
        $nfo=array();
        $values=explode(';', $val);
        //0:type, 1:name, 2:file, 3:lang, 4:action

        $result=true;
        if($values[4]=='1A')
        {
          //import from file to database the new keys
          $keydiff=$this->compare_file_and_database_keys($values[0],$values[1],$values[2],$values[3]);
          foreach($keydiff['keynfo'] as $key2 => $val2)
          {
            if($val2[0]=='4')
            {
              $result2=$this->insert_key_translation($keydiff['filenfo']['id'], $key2, $user['id'], $val2[1], 'valide_it');
              if(!$result2) { $result=false; }
            }
          }

          $template_datas['result_row'][]=array(
            'RESULT_COLOR' => ($result==true)?$this->my_config['color_bars3']:$this->my_config['color_bars1'],
            'TYPE' => $values[0],
            'NAME' => $values[1],
            'FILE' => $values[2],
            'LANG' => $values[3],
            'ACTION' => l10n('g001_do_upgrade_1a'),
            'ACTION_RESULT' => ($result==true)?l10n('g001_ok'):l10n('g001_ko')
          );
          $this->update_date_file($keydiff['filenfo']);
        }
        elseif($values[4]=='1B')
        {
          //delete in database keys who aren't in file
          $keydiff=$this->compare_file_and_database_keys($values[0],$values[1],$values[2],$values[3]);
          foreach($keydiff['keynfo'] as $key2 => $val2)
          {
            if($val2[0]=='5')
            {
              $result2=$this->delete_key($keydiff['filenfo']['id'], $key2, $user['id']);
              if(!$result2) { $result=false; }
            }
          }

          $template_datas['result_row'][]=array(
            'RESULT_COLOR' => ($result==true)?$this->my_config['color_bars3']:$this->my_config['color_bars1'],
            'TYPE' => $values[0],
            'NAME' => $values[1],
            'FILE' => $values[2],
            'LANG' => $values[3],
            'ACTION' => l10n('g001_do_upgrade_1b'),
            'ACTION_RESULT' => ($result==true)?l10n('g001_ok'):l10n('g001_ko')
          );
          $this->update_date_file($keydiff['filenfo']);
        }
        elseif($values[4]=='2A')
        {
          //import complete file into database
//$tmp=print_r($values, true)."<br/>";
          if($values[0]=='piwigo')
          {
            // ./language/{lang}/{file}
            $fic=PHPWG_ROOT_PATH.'language/'.$values[3].'/'.$values[2];
          }
          else
          {
            // ./plugins/{name}/language/{lang}/{file}
            $fic=PHPWG_PLUGINS_PATH.$values[1].'/language/'.$values[3].'/'.$values[2];
          }
//$tmp.=$fic."<br/>";
          $nfo[0]=$this->analyze_filename($fic);
//$tmp.=print_r($nfo, true)."<br/>";
//return($tmp);
          $result=$this->load_lang_files('',$nfo,$user['id']);

          $template_datas['result_row'][]=array(
            'RESULT_COLOR' => (count($result)==0)?$this->my_config['color_bars3']:$this->my_config['color_bars1'],
            'TYPE' => $values[0],
            'NAME' => $values[1],
            'FILE' => $values[2],
            'LANG' => $values[3],
            'ACTION' => l10n('g001_do_upgrade_2a'),
            'ACTION_RESULT' => (count($result)==0)?l10n('g001_ok'):l10n('g001_ko')
          );
        }
        elseif($values[4]=='3A')
        {
          //purge file from database
          $nfo=$this->get_file_info($values[0],$values[1],$values[2],$values[3]);
          $result=$this->erase_file_from_database($nfo[$values[3]]['id']);

          $template_datas['result_row'][]=array(
            'RESULT_COLOR' => ($result==true)?$this->my_config['color_bars3']:$this->my_config['color_bars1'],
            'TYPE' => $values[0],
            'NAME' => $values[1],
            'FILE' => $values[2],
            'LANG' => $values[3],
            'ACTION' => l10n('g001_do_upgrade_3a'),
            'ACTION_RESULT' => ($result==true)?l10n('g001_ok'):l10n('g001_ko')
          );
        }
        else
        {
          // ???
        }
      }
      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      display backup/restore status
    */
    function ajax_backup_restore_status()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_backup_restore_status.tpl');

      if(file_exists($this->backup_file_name))
      {
        $template_datas=array(
          'RESTORE_DISABLED' => "",
          'RESTORE_NFO' => sprintf(l10n('g001_dorestore2'), date("Y-m-d H:i:s", filemtime($this->backup_file_name)))
        );
      }
      else
      {
        $template_datas=array(
          'RESTORE_DISABLED' => " disabled ",
          'RESTORE_NFO' => l10n('g001_dorestore3')
        );
      }
      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      do database backup
    */
    function ajax_backup_restore_dobackup()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_backup_restore_do.tpl');

      if(is_adviser())
      {
        $template_datas=array(
          'ACTION_RESULT' => l10n("g001_translator_adviser_not_allowed"),
          'ACTION_CLASS' => 'errors',
          'ACTION_DETAIL_TEXT' => ""
        );
      }
      elseif(file_exists($this->backup_file_name))
      {
        // backup of previous backup_file
        $backup=dirname($this->backup_file_name).'/'.basename($this->backup_file_name, ".sql").'_'.date('YmdHis', filemtime($this->backup_file_name)).".sql";
        @copy($this->backup_file_name, $backup);
      }

      $this->tables_management = new manage_tables($this->tables);
      $result=$this->tables_management->export($this->backup_file_name,
        array(
          'drop' => false,
          'delete' => true,
          'create' => false,
          'insert' => true,
          'colnames' => true
        ),
        array(
          'langs' => '',
          'files' => '',
          'keys' => ''
        ),
        'Export from TRANSLATOR r'.TRANSLATOR_VERSION,
        false
      );

      if($result===false)
      {
        $template_datas=array(
          'ACTION_RESULT' => l10n('g001_backupko'),
          'ACTION_CLASS' => 'errors',
          'ACTION_DETAIL_TEXT' => ""
        );
      }
      else
      {
        $template_datas=array(
          'ACTION_RESULT' => l10n('g001_backupok'),
          'ACTION_CLASS' => 'infos',
          'ACTION_DETAIL_TEXT' => l10n('g001_backup_detail_backup'),
          'ACTION_DETAIL' => array()
        );

        $nfo=explode('@', $result);
        $nfotext='';
        foreach($nfo as $key => $val)
        {
          if($val!="")
          {
            $nfo2=explode(':',$val.":");
            $template_datas['action_detail'][]=sprintf(l10n('g001_backup_nfo'), "<i>".$nfo2[0]."</i>", $nfo2[1]);
          }
        }
      }
      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      do database restore
    */
    function ajax_backup_restore_dorestore()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                              dirname($this->filelocation).'/admin/plugin_admin_maintenance_backup_restore_do.tpl');

      if(is_adviser())
      {
        $template_datas=array(
            'ACTION_RESULT' => l10n("g001_translator_adviser_not_allowed"),
            'ACTION_CLASS' => 'errors'
        );
      }
      elseif(file_exists($this->backup_file_name))
      {
        $this->tables_management = new manage_tables($this->tables);
        $result=$this->tables_management->import($this->backup_file_name);
        if(count($result['errors'])>0)
        {
          if($result['errors'][0]==-1)
          {
            $template_datas=array(
              'ACTION_RESULT' => l10n('g001_restoreko_file_not_exists'),
              'ACTION_CLASS' => 'errors'
            );
          }
          elseif($result['errors'][0]==-2)
          {
            $template_datas=array(
              'ACTION_RESULT' => l10n('g001_restoreko_file_not_open'),
              'ACTION_CLASS' => 'errors'
            );
          }
          else
          {
            $template_datas=array(
              'ACTION_RESULT' => l10n('g001_restoreko_not_complete'),
              'ACTION_CLASS' => 'errors',
              'ACTION_DETAIL_TEXT' => "",
              'ACTION_DETAIL' => array()
            );

            $template_datas['ACTION_DETAIL'][] = sprintf(l10n('g001_restore_detail_numdelete'), $result['numdelete']);
            $template_datas['ACTION_DETAIL'][] = sprintf(l10n('g001_restore_detail_numinsert'), $result['numinsert']);
            $template_datas['ACTION_DETAIL'][] = sprintf(l10n('g001_restore_detail_numerrors'), count($result['errors']));

            foreach($result['errors'] as $key => $val)
            {
              $template_datas['ACTION_DETAIL'][] = $val."<hr>";
            }
          }
        }
        else
        {
          $template_datas=array(
            'ACTION_RESULT' => l10n('g001_restoreok'),
            'ACTION_CLASS' => 'infos',
            'ACTION_DETAIL_TEXT' => "",
            'ACTION_DETAIL' => array()
          );
          $template_datas['ACTION_DETAIL'][] = sprintf(l10n('g001_restore_detail_numdelete'), $result['numdelete']);
          $template_datas['ACTION_DETAIL'][] = sprintf(l10n('g001_restore_detail_numinsert'), $result['numinsert']);
        }
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      return all keys nfo in an html formatted string
      for each keys, return :
        - an HTML description
    */
    function ajax_allkey_nfo()
    {
      //global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");

      $file_id=$_REQUEST['fileid'];
      $returnedhtml='';
      $nfofile=$this->get_file_info_by_id($file_id);

      foreach($_POST as $postkey => $postval)
      {
        $local_tpl->set_filename('body_page',
                      dirname($this->filelocation).'/admin/plugin_admin_edit_detail3.tpl');

        $nfokey=$this->get_key_nfo($file_id, base64_decode($postval));

        if($this->is_translator())
        {
          $translator_nfo=$this->get_translator_info();
          if($this->recursive_in_array($translator_nfo['default_displayed_language'], $nfofile['langs']))
          {
            $selected_lang=$translator_nfo['default_displayed_language'];
          }
          else
          {
            $selected_lang=$this->my_config['mainlang'];
          }
        }
        else
        {
          $selected_lang=$this->my_config['mainlang'];
        }


        $_REQUEST['ffrom']=substr($selected_lang,0,2);
        $_REQUEST['fkey']=$postval;
        $_REQUEST['translatelnk']='y';
        $nfo_value=$this->ajax_key_value();

        $template_datas=array(
          'TEXT' => $nfokey[0]['translation'],
          'ID64' => $postval,
          'VERSION' => $nfokey[0]['version'],
          'TRANSLATE_MODEL' => $nfo_value,
          'langs' => array(),
          'versions_rows' => array(),
          'valide_it' => false,
          'delete_it' => false
        );





        foreach($nfofile['langs'] as $nfo)
        {
          $template_datas['langs'][]=array(
            'LANG' => $nfo['id'],
            'SELECT' => ($nfo['language']==$selected_lang)?' selected':'',
            'TEXT' => $nfo['language']
          );
          if($nfo['language']==$selected_lang)
          {
            $_REQUEST['fileid']=$nfo['id'];
          }
        }

        if(($nfokey[0]['status']=='valide_it')||($nfokey[0]['status']=='deleted'))
        {
          $template_datas['valide_it']=true;
        }
        if($nfokey[0]['status']!='deleted')
        {
          $template_datas['delete_it']=true;
        }

        foreach($nfokey as $key =>$nfo)
        {
          $template_datas['versions_rows'][]=array(
            'ID' => $postval,
            'VERSION' => $nfo['version'],
            'CREATE_DATE' => $nfo['date'],
            'CREATE_BY' => $nfo['create_by_name'],
            'VALIDATE_DATE' => ($nfo['validate_date']=='0000-00-00 00:00:00')?'':$nfo['validate_date'],
            'VALIDATE_BY' => $nfo['validate_by_name'],
            'VALUE' => $nfo['translation']
          );
        }

        $local_tpl->assign("datas", $template_datas);
        $returnedhtml.="<TRANSLATOR_ID ref='".$postval."'>".$local_tpl->parse('body_page', true);
      }
      return($returnedhtml);
    }



    /*
      return a formatted list of translators 
    */
    function ajax_get_translators_list()
    {
      global $user;

      $local_tpl = new Template(TRANSLATOR_PATH."admin/", "");
      $local_tpl->set_filename('body_page',
                    dirname($this->filelocation).'/admin/plugin_admin_translators_detail1.tpl');

      $translators=$this->get_translators_list();

      $istranslator=$this->is_translator();

      $template_datas=array('translators_row'=>array());
      foreach($translators as $translator)
      {
        $template_datas['translators_row'][]=array(
          "ID" => $translator['id'],
          "USERNAME" => $translator['name'],
          "FLAG" => TRANSLATOR_PATH."img/".strtolower($translator['country']).".png",
          "COUNTRY" => $this->get_formatted_country($translator['country']),
          "TOWN" => $translator['town'],
          "NATIVE_LANGUAGE" => implode(", ",$this->make_spoken_languages($translator['native_language'])),
          "SEX" => ($translator['sex']=="")?"":l10n("g001_translator_sex".strtolower($translator['sex'])),
          "AGE" => $translator['age'],
          "SPOKEN_LANGUAGES" => implode(", ", $this->make_spoken_languages($translator['spoken_language'])),
          "URLEDIT" => (($istranslator && ($user['id']==$translator['id'])) || !$istranslator)?$this->page_link."&f_tabsheet=translators&action=edit&user_id=".$translator['id']:"",
          "URLSHOW" => ($translator['spoken_language']!="")?$this->page_link."&f_tabsheet=translators&action=show&user_id=".$translator['id']:"",
          "STATUSNFO" => ($translator['adviser']=='true')?l10n('g001_translator_no_nfo'):l10n('g001_translator_not_validated'),
          "TOVALIDATE" => ($translator['adviser']=='false' && !$istranslator)?"y":"n"
        );
      }

      $local_tpl->assign("datas", $template_datas);
      return($local_tpl->parse('body_page', true));
    }


    /*
      validate a user to be a translator
    */
    function ajax_validate_user()
    {
      global $user;

      if($this->is_translator())
      {
        return( l10n("g001_translator_not_allowed"));
      }
      elseif(is_adviser())
      {
        return( l10n("g001_translator_adviser_not_allowed"));
      }
      else
      {
        if($this->validate_user($_REQUEST['user_id']))
        {
          $nfo=$this->get_translators_info($_REQUEST['user_id']);
          return(($nfo['spoken_language']=="")?l10n('g001_translator_no_nfo'):"OK");
        }
        else
        {
          return("KO?");
        }
      }
    }


  } //class

?>
